var sudoku9solution, __extends = this && this.__extends || function() {
var e = function(t, l) {
return (e = Object.setPrototypeOf || {
__proto__: []
} instanceof Array && function(e, t) {
e.__proto__ = t;
} || function(e, t) {
for (var l in t) Object.prototype.hasOwnProperty.call(t, l) && (e[l] = t[l]);
})(t, l);
};
return function(t, l) {
if ("function" != typeof l && null !== l) throw new TypeError("Class extends value " + String(l) + " is not a constructor or null");
e(t, l);
function o() {
this.constructor = t;
}
t.prototype = null === l ? Object.create(l) : (o.prototype = l.prototype, new o());
};
}(), __values = this && this.__values || function(e) {
var t = "function" == typeof Symbol && Symbol.iterator, l = t && e[t], o = 0;
if (l) return l.call(e);
if (e && "number" == typeof e.length) return {
next: function() {
e && o >= e.length && (e = void 0);
return {
value: e && e[o++],
done: !e
};
}
};
throw new TypeError(t ? "Object is not iterable." : "Symbol.iterator is not defined.");
}, __read = this && this.__read || function(e, t) {
var l = "function" == typeof Symbol && e[Symbol.iterator];
if (!l) return e;
var o, r, n = l.call(e), s = [];
try {
for (;(void 0 === t || t-- > 0) && !(o = n.next()).done; ) s.push(o.value);
} catch (e) {
r = {
error: e
};
} finally {
try {
o && !o.done && (l = n.return) && l.call(n);
} finally {
if (r) throw r.error;
}
}
return s;
}, __spreadArray = this && this.__spreadArray || function(e, t) {
for (var l = 0, o = t.length, r = e.length; l < o; l++, r++) e[r] = t[l];
return e;
};

(function(e) {
var t = function() {
function e(e, t) {
this.palaceCells = [];
this.rowCells = [];
this.columnCells = [];
this.cells = [];
this.palaceCells = [ [], [], [], [], [], [], [], [], [] ];
this.columnCells = [ [], [], [], [], [], [], [], [], [] ];
this.rowCells = [ [], [], [], [], [], [], [], [], [] ];
for (var o = [ "A", "B", "C", "D", "E", "F", "G", "H", "I" ], r = 0; r < 81; r++) {
var n = new l();
n.cellIndex = r;
n.palaceIndex = Math.floor(r % 9 / 3) + 3 * Math.floor(Math.floor(r / 9) / 3);
n.rowIndex = Math.floor(r / 9);
n.columnIndex = r % 9;
n.question = e[r];
n.right = t[r];
n.answer = 0;
n.notes = [];
n.userNotes = [];
n.systemNotes = [];
n.coordinate = o[n.rowIndex] + "" + (n.columnIndex + 1);
this.palaceCells[n.palaceIndex].push(n);
this.rowCells[n.rowIndex].push(n);
this.columnCells[n.columnIndex].push(n);
this.cells.push(n);
}
this.fillAllNote();
}
e.prototype.fillAllNote = function() {
var e, t;
try {
for (var l = __values(this.cells), o = l.next(); !o.done; o = l.next()) {
var r = o.value;
0 === r.question && 0 === r.answer ? r.systemNotes = this.getBeCanNums(r.cellIndex) : r.systemNotes = [];
}
} catch (t) {
e = {
error: t
};
} finally {
try {
o && !o.done && (t = l.return) && t.call(l);
} finally {
if (e) throw e.error;
}
}
};
e.prototype.writeAnswer = function(e, t) {
var l = this;
if (this.cells[e].right !== t) throw new Error("write answer error, answer not equal right" + e + "," + t);
this.cells[e].answer = t;
this.cells[e].userNotes = [];
this.cells[e].systemNotes = [];
this.cells[e].notes = [];
this.palaceCells[this.cells[e].palaceIndex].forEach(function(e) {
0 <= e.notes.indexOf(t) && l.writeNotes(e.cellIndex, e.notes.filter(function(e) {
return e !== t;
}));
});
this.rowCells[this.cells[e].rowIndex].forEach(function(e) {
0 <= e.notes.indexOf(t) && l.writeNotes(e.cellIndex, e.notes.filter(function(e) {
return e !== t;
}));
});
this.columnCells[this.cells[e].columnIndex].forEach(function(e) {
0 <= e.notes.indexOf(t) && l.writeNotes(e.cellIndex, e.notes.filter(function(e) {
return e !== t;
}));
});
};
e.prototype.writeNotes = function(e, t) {
this.cells[e].notes = __spreadArray([], __read(t));
this.cells[e].userNotes.length > 0 && (this.cells[e].userNotes = __spreadArray([], __read(t)));
};
e.prototype.getBeCanNums = function(e) {
var t = new Map(), l = this.cells[e];
this.cells.forEach(function(e) {
if (l.rowIndex === e.rowIndex || l.columnIndex === e.columnIndex || l.palaceIndex === e.palaceIndex) {
var o = e.questionOrAnswer;
0 < o && !t.has(o) && t.set(o, e.cellIndex);
}
});
for (var o = [], r = 0; r < 9; r++) o.push(r + 1);
return o.filter(function(e) {
return !t.has(e);
});
};
return e;
}();
e.Sudoku = t;
var l = function() {
function e() {
this.coordinate = "";
}
Object.defineProperty(e.prototype, "questionOrAnswer", {
get: function() {
return 0 < this.question ? this.question : 0 < this.answer ? this.answer : 0;
},
enumerable: !1,
configurable: !0
});
return e;
}();
e.Cell = l;
var o = function() {
function e() {
this.bindCell = null;
this.style = e.STYLE_DEFAULT;
this.notesStress = [];
this.notesRemove = [];
this.notesAdd = [];
this.notesUnique = 0;
this.numWrite = 0;
this.remindNum = 0;
this.numIsStress = !1;
this.desc = "";
}
e.STYLE_RELATION = 1;
e.STYLE_AFFECTED = 2;
e.STYLE_REFER = 3;
e.STYLE_ERROR = 4;
e.STYLE_EXCLUDE = 5;
e.STYLE_DEFAULT = 0;
return e;
}();
e.AnalysisCell = o;
var r = function() {
this.relationCells = [];
this.relationRows = [];
this.relationColumn = [];
this.relationPalace = [];
this.noFrameRows = [];
this.noFrameColumn = [];
this.noFramePalace = [];
this.stressRows = [];
this.stressColumn = [];
this.stressPalace = [];
this.supplyIndex = [];
this.supplyNotes = [];
this.influenceRCP = [ [], [], [] ];
this.subStep = [];
this.name = "";
this.desc = "";
this.descData = [];
this.descTpl = "";
this.descKey = "";
};
e.SubAnalysisCell = r;
var n = function() {
this.relationRows = [];
this.relationColumn = [];
this.relationPalace = [];
this.remindRows = [];
this.remindColumn = [];
this.remindPalace = [];
this.relationCells = [];
};
e.SubStep = n;
var s = function() {
function e(e) {
this.relationCells = [];
this.relationRows = [];
this.relationColumn = [];
this.relationPalace = [];
this.noFrameRows = [];
this.noFrameColumn = [];
this.noFramePalace = [];
this.stressRows = [];
this.stressColumn = [];
this.stressPalace = [];
this.supplyIndex = [];
this.supplyNotes = [];
this.influenceRCP = [ [], [], [] ];
this.step = [];
this.name = "";
this.desc = "";
this.descData = [];
this.descTpl = "";
this.descKey = "";
this.sudoku = e;
}
e.prototype.find = function(e) {
void 0 === e && (e = 0);
return null;
};
e.prototype.apply = function() {
var e, t, l = function(e) {
0 < e.numWrite && o.sudoku.writeAnswer(e.bindCell.cellIndex, e.numWrite);
if (0 < e.notesRemove.length) {
var t = e.bindCell.notes.filter(function(t) {
return 0 > e.notesRemove.indexOf(t);
});
o.sudoku.writeNotes(e.bindCell.cellIndex, t);
}
0 < e.notesUnique && o.sudoku.writeAnswer(e.bindCell.cellIndex, e.notesUnique);
if (0 < e.notesAdd.length) {
t = e.bindCell.userNotes.concat(e.notesAdd);
o.sudoku.cells[e.bindCell.cellIndex].userNotes = t;
o.sudoku.writeNotes(e.bindCell.cellIndex, t);
}
}, o = this;
try {
for (var r = __values(this.relationCells), n = r.next(); !n.done; n = r.next()) l(n.value);
} catch (t) {
e = {
error: t
};
} finally {
try {
n && !n.done && (t = r.return) && t.call(r);
} finally {
if (e) throw e.error;
}
}
for (var s = 0; s < this.supplyIndex.length; s++) this.sudoku.cells[this.supplyIndex[s]].userNotes = this.sudoku.cells[this.supplyIndex[s]].notes;
this.sudoku.fillAllNote();
};
e.prototype.arrayCountValue = function(e) {
if (!Array.isArray(e) || e.length < 0) return [];
for (var t = new Object(), l = 0; l < e.length; l++) {
var o = e[l] + "";
null == t[o] ? t[o] = 1 : t[o] += 1;
}
return t;
};
e.prototype.getCellNotes = function(e) {
var t, l, o = [];
try {
for (var r = __values(e), n = r.next(); !n.done; n = r.next()) {
var s = n.value;
s.notes.length > 0 && o.push(s.notes);
}
} catch (e) {
t = {
error: e
};
} finally {
try {
n && !n.done && (l = r.return) && l.call(r);
} finally {
if (t) throw t.error;
}
}
return o;
};
e.prototype.mergerUniqueArr = function(e) {
for (var t = [], l = 0; l < e.length; l++) t = t.concat(e[l]);
return this.uniqueArr(t);
};
e.prototype.intersectionArr = function(e, t) {
return e.filter(function(e) {
return t.indexOf(e) > -1;
});
};
e.prototype.uniqueArr = function(e) {
for (var t = [], l = 0; l < e.length; l++) -1 == t.indexOf(e[l]) && t.push(e[l]);
return t;
};
e.prototype.hideCombination = function(e, t) {
void 0 === t && (t = 2);
if (e.length < t) return [];
for (var l = this.mergerUniqueArr(e), o = this.combination(l, t), r = function(l) {
for (var r = 0, s = !1, i = 0; i < e.length; i++) {
if (n.intersectionArr(o[l], e[i]).length > 0) {
r++;
e[i].filter(function(e) {
return -1 == o[l].indexOf(e);
}).length > 0 && (s = !0);
}
if (r > t) break;
}
if (r == t && s) return {
value: o[l]
};
}, n = this, s = 0; s < o.length; s++) {
var i = r(s);
if ("object" == typeof i) return i.value;
}
return [];
};
e.prototype.combination = function(e, t) {
void 0 === t && (t = 5);
for (var l = e.length, o = Math.pow(2, l), r = [], n = Math.pow(2, t) - 1; n < o; n++) {
for (var s = 0, i = [], a = 0; a < l; a++) {
var u = Math.pow(2, a);
if ((n & u) == u) {
i.push(e[a]);
s++;
}
}
s == t && r.push(i);
}
return r;
};
e.prototype.checkNum = function(e, t) {
void 0 === t && (t = 1);
var l = [];
for (var o in e) e[o] == t && l.push(Number(o));
return l;
};
e.prototype.rowNumberToLetter = function(e) {
return [ "A", "B", "C", "D", "E", "F", "G", "H", "I" ][e];
};
e.prototype.supplySystemNotes = function(e) {
for (var t, l, o = [], r = [], n = 0; n < e.length; n++) try {
for (var s = (t = void 0, __values(e[n])), i = s.next(); !i.done; i = s.next()) {
var a = i.value;
if (0 == a.questionOrAnswer && 0 == a.userNotes.length) {
o.push(a.cellIndex);
r.push(a.systemNotes);
}
}
} catch (e) {
t = {
error: e
};
} finally {
try {
i && !i.done && (l = s.return) && l.call(s);
} finally {
if (t) throw t.error;
}
}
this.supplyIndex = o;
this.supplyNotes = r;
};
e.prototype.clone = function(e) {
if ("object" != typeof e) return e;
if (null == e) return e;
var t;
t = e instanceof Array ? new Array() : new Object();
for (var l in e) t[l] = this.clone(e[l]);
return t;
};
e.prototype.getStep = function() {
var t, l = "";
if (this.relationColumn.length > 0) {
l = "第 <b><color=" + e.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b> 列";
t = {
type: "c",
value: "<b><color=" + e.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b>"
};
} else if (this.relationRows.length > 0) {
l = "第 <b><color=" + e.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b> 行";
t = {
type: "r",
value: "<b><color=" + e.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b>"
};
} else if (this.relationPalace.length > 0) {
l = "第 <b><color=" + e.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫";
t = {
type: "b",
value: "<b><color=" + e.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
};
}
this.descKey = "yxwyhxs0";
this.descData = [ [ t ], "<b><color=" + e.tipsNumStyle + ">" + this.relationCells[0].notesStress[0] + "</color></b>", "<b><color=" + e.AffectedCellStyle + ">" + this.relationCells[0].bindCell.coordinate + "</color></b>" ];
var o = new r();
o.noFrameRows = this.relationRows;
o.noFrameColumn = this.relationColumn;
o.noFramePalace = this.relationPalace;
o.relationCells = this.clone(this.relationCells);
o.relationCells[0].notesStress = [];
var s = new n();
s.remindRows = this.relationRows;
s.remindColumn = this.relationColumn;
s.remindPalace = this.relationPalace;
o.supplyIndex = this.supplyIndex;
o.supplyNotes = this.supplyNotes;
o.subStep.push(s);
o.desc = "留意" + l + "，以及这些区域中出现的数字。";
o.descKey = "xxwyhxs1";
o.descData = [ [ t ] ];
var i = new r();
i.relationRows = this.relationRows;
i.relationColumn = this.relationColumn;
i.relationPalace = this.relationPalace;
i.supplyIndex = this.supplyIndex;
i.supplyNotes = this.supplyNotes;
i.relationCells = this.clone(this.relationCells);
var a = new n();
a.relationCells = this.clone(this.relationCells);
i.subStep.push(a);
i.desc = "数字 <b><color=" + e.tipsNumStyle + ">" + this.relationCells[0].notesStress[0] + "</color></b> 在此区域仅出现了一次。";
i.descKey = "yxwyhxs2";
i.descData = [ "<b><color=" + e.tipsNumStyle + ">" + this.relationCells[0].notesStress[0] + "</color></b>" ];
var u = this.clone(i);
u.subStep = [];
u.relationCells[0].remindNum = u.relationCells[0].bindCell.right;
u.relationCells[0].notesStress = [];
u.desc = "那么单元格 <b><color=" + e.AffectedCellStyle + ">" + this.relationCells[0].bindCell.coordinate + "</color></b> 可以填的数字只能为 <b><color=" + e.tipsNumStyle + ">" + this.relationCells[0].notesStress[0] + "</color></b>。";
u.descKey = "xxwyhxs3";
u.descData = [ "<b><color=" + e.AffectedCellStyle + ">" + this.relationCells[0].bindCell.coordinate + "</color></b>", "<b><color=" + e.tipsNumStyle + ">" + this.relationCells[0].notesStress[0] + "</color></b>" ];
this.step = [ o, i, u ];
};
e.tipsRowColumnPalaceStyle = "#2285F2";
e.tipsNumStyle = "#2285F2";
e.delNumStyle = "#F20704";
e.tipsCellStyle = "#5EB406";
e.AffectedCellStyle = "#FAB807";
return e;
}();
e.Road = s;
var i = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.name = "单元唯一法";
return t;
}
t.prototype.find = function() {
var e, t;
try {
for (var l = __values(this.sudoku.cells), r = l.next(); !r.done; r = l.next()) {
var n = r.value;
if (!(0 < n.questionOrAnswer)) {
var i = this.sudoku.palaceCells[this.sudoku.cells[n.cellIndex].palaceIndex].filter(function(e) {
return 0 < e.questionOrAnswer;
}), a = this.sudoku.rowCells[this.sudoku.cells[n.cellIndex].rowIndex].filter(function(e) {
return 0 < e.questionOrAnswer;
}), u = this.sudoku.columnCells[this.sudoku.cells[n.cellIndex].columnIndex].filter(function(e) {
return 0 < e.questionOrAnswer;
}), c = 8 == i.length ? i : 8 == a.length ? a : 8 == u.length ? u : [], h = 8 == i.length ? "palace" : 8 == a.length ? "row" : 8 == u.length ? "column" : "";
if (8 == c.length) {
var d = new o();
d.bindCell = n;
d.numWrite = n.notes[0];
0 == n.userNotes.length && (d.remindNum = n.notes[0]);
d.style = o.STYLE_AFFECTED;
this.relationCells.push(d);
var f = "", y = void 0;
switch (h) {
case "palace":
this.relationPalace = [ n.palaceIndex ];
f = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (n.palaceIndex + 1) + "</color></b> 宫";
y = {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (n.palaceIndex + 1) + "</color></b>"
};
break;

case "row":
this.relationRows = [ n.rowIndex ];
f = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(n.rowIndex) + "</color></b> 行";
y = {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(n.rowIndex) + "</color></b>"
};
break;

case "column":
this.relationColumn = [ n.columnIndex ];
f = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (n.columnIndex + 1) + "</color></b> 列";
y = {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (n.columnIndex + 1) + "</color></b>"
};
}
this.desc = f + "中，仅剩余 <b><color=" + s.AffectedCellStyle + ">" + n.coordinate + "</color></b> 未填答案，此处只能填 <b><color=" + s.tipsNumStyle + ">" + n.notes[0] + "</color></b> 。";
this.descKey = "dywyf";
this.descData = [ [ y ], "<b><color=" + s.AffectedCellStyle + ">" + n.coordinate + "</b></color>", "<b><color=" + s.tipsNumStyle + ">" + n.notes[0] + "</color></b>" ];
return this;
}
}
}
} catch (t) {
e = {
error: t
};
} finally {
try {
r && !r.done && (t = l.return) && t.call(l);
} finally {
if (e) throw e.error;
}
}
return null;
};
return t;
}(s);
e.RoadDominantUniquenessRemainder = i;
var a = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.name = "显性唯一候选数";
t.desc = "";
return t;
}
t.prototype.find = function() {
var e, t, l, i, a, u;
try {
for (var c = __values(this.sudoku.cells), h = c.next(); !h.done; h = c.next()) {
var d = h.value;
if (!(0 < d.questionOrAnswer) && 1 === d.notes.length) {
var f = this.getWrittenCells(d.cellIndex);
if (this.sudoku.palaceCells.length - 1 === f.length) {
try {
for (var y = (l = void 0, __values(f)), p = y.next(); !p.done; p = y.next()) {
var C = p.value;
(A = new o()).bindCell = C;
A.style = o.STYLE_REFER;
A.numIsStress = !0;
this.relationCells.push(A);
}
} catch (e) {
l = {
error: e
};
} finally {
try {
p && !p.done && (i = y.return) && i.call(y);
} finally {
if (l) throw l.error;
}
}
var b = new o();
b.bindCell = d;
b.numWrite = d.notes[0];
0 == d.userNotes.length && (b.remindNum = d.notes[0]);
b.style = o.STYLE_AFFECTED;
this.relationCells.push(b);
var m = __read(this.getRCP(this.relationCells), 2), v = m[0], w = m[1], x = v.join("、");
this.desc = x + "，已包含除 <b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b> 以外的其他数字，那么 <b><color=" + s.AffectedCellStyle + ">" + d.coordinate + "</color></b> 只能填 <b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b> 。";
this.descKey = "xxwyhxs0";
this.descData = [ w, "<b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b>", "<b><color=" + s.AffectedCellStyle + ">" + d.coordinate + "</color></b>" ];
var S = new r();
S.noFrameColumn = this.noFrameColumn;
S.noFrameRows = this.noFrameRows;
S.noFramePalace = this.noFramePalace;
var g = new n();
g.remindRows = this.noFrameRows;
var N = new n();
N.remindColumn = this.noFrameColumn;
var R = new n();
R.remindPalace = this.noFramePalace;
S.subStep = [ g, N, R ];
S.desc = "留意" + x + "，以及这些区域中出现的数字。";
S.descKey = "xxwyhxs1";
S.descData = [ w ];
this.step.push(S);
var _ = this.clone(S);
try {
for (var P = (a = void 0, __values(f)), I = P.next(); !I.done; I = P.next()) {
var A;
C = I.value;
(A = new o()).bindCell = C;
A.style = o.STYLE_REFER;
A.numIsStress = !0;
A.remindNum = C.questionOrAnswer;
_.relationCells.push(A);
}
} catch (e) {
a = {
error: e
};
} finally {
try {
I && !I.done && (u = P.return) && u.call(P);
} finally {
if (a) throw a.error;
}
}
_.subStep = [];
_.desc = "在这些高亮区域中，数字 <b><color=" + s.tipsNumStyle + ">1 ~ 9</color></b> 中只有数字 <b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b> 没有出现。";
_.descKey = "xxwyhxs2";
_.descData = [ "<b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b>" ];
this.step.push(_);
var k = this.clone(_);
k.relationCells = this.relationCells;
k.desc = "那么单元格 <b><color=" + s.AffectedCellStyle + ">" + d.coordinate + "</color></b> 可以填的数字只能为 <b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b> 。";
k.descKey = "xxwyhxs3";
k.descData = [ "<b><color=" + s.AffectedCellStyle + ">" + d.coordinate + "</color></b>", "<b><color=" + s.tipsNumStyle + ">" + d.notes[0] + "</color></b>" ];
this.step.push(k);
return this;
}
}
}
} catch (t) {
e = {
error: t
};
} finally {
try {
h && !h.done && (t = c.return) && t.call(c);
} finally {
if (e) throw e.error;
}
}
return null;
};
t.prototype.getWrittenCells = function(e) {
var t, l = [ this.sudoku.palaceCells[this.sudoku.cells[e].palaceIndex].filter(function(e) {
return 0 < e.questionOrAnswer;
}), this.sudoku.rowCells[this.sudoku.cells[e].rowIndex].filter(function(e) {
return 0 < e.questionOrAnswer;
}), this.sudoku.columnCells[this.sudoku.cells[e].columnIndex].filter(function(e) {
return 0 < e.questionOrAnswer;
}) ];
l.sort(function(e, t) {
return e.length >= t.length ? 1 : 0;
});
for (var o = 1; o < 3; o++) {
var r = l[o].filter(function(e) {
return 0 > l[0].findIndex(function(t) {
return e.questionOrAnswer === t.questionOrAnswer;
});
});
(t = l[0]).push.apply(t, __spreadArray([], __read(r)));
}
return l[0];
};
t.prototype.getRCP = function(e) {
var t, l, o = e.filter(function(e) {
return e.numWrite > 0 || e.notesUnique > 0;
});
if (0 == e.filter(function(e) {
return 0 == e.numWrite && 0 == e.notesUnique;
}).length) return [ [], [] ];
var r = [], n = [], i = [];
try {
for (var a = __values(e), u = a.next(); !u.done; u = a.next()) {
var c = u.value;
c.bindCell.palaceIndex == o[0].bindCell.palaceIndex && -1 == r.indexOf(c.bindCell.palaceIndex) ? r.push(c.bindCell.palaceIndex) : c.bindCell.rowIndex == o[0].bindCell.rowIndex && -1 == n.indexOf(c.bindCell.rowIndex) ? n.push(c.bindCell.rowIndex) : c.bindCell.columnIndex == o[0].bindCell.columnIndex && -1 == i.indexOf(c.bindCell.columnIndex) && i.push(c.bindCell.columnIndex);
}
} catch (e) {
t = {
error: e
};
} finally {
try {
u && !u.done && (l = a.return) && l.call(a);
} finally {
if (t) throw t.error;
}
}
var h = [ n, i, r ], d = [], f = [];
if (h[0].length > 0) for (var y = 0; y < h[0].length; y++) {
d.push("第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(h[0][y]) + "</color></b> 行");
f.push({
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(h[0][y]) + "</color></b>"
});
this.noFrameRows.push(h[0][y]);
}
if (h[1].length > 0) for (y = 0; y < h[1].length; y++) {
d.push("第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (h[1][y] + 1) + "</color></b> 列");
f.push({
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (h[1][y] + 1) + "</color></b>"
});
this.noFrameColumn.push(h[1][y]);
}
if (h[2].length > 0) for (y = 0; y < h[2].length; y++) {
d.push("第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (h[2][y] + 1) + "</color></b> 宫");
f.push({
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (h[2][y] + 1) + "</color></b>"
});
this.noFramePalace.push(h[2][y]);
}
return [ d, f ];
};
return t;
}(s);
e.RoadDominantUniqueness = a;
var u = function() {
this.cellIndex = 0;
this.num = 0;
this.weight = 0;
this.type = 0;
this.plaseNum = [];
this.rowNum = [];
this.columnNum = [];
};
e.HideNumOneAnsCellDate = u;
var c = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.name = "摒除法";
return t;
}
t.prototype.find = function() {
for (var e, l, o, r, n, s, i, a, c, h, d, f, y = [], p = 0; p < 9; p++) {
var C = this.getCellNotes(this.sudoku.palaceCells[p]), b = this.hideCombination(C, 1);
try {
for (var m = (e = void 0, __values(b)), v = m.next(); !v.done; v = m.next()) {
var w = v.value;
try {
for (var x = (o = void 0, __values(this.sudoku.palaceCells[p])), S = x.next(); !S.done; S = x.next()) if ((T = S.value).notes.length > 0 && -1 != T.notes.indexOf(w)) {
if (null == (O = this.getWrittenCellsPalaceWeight(T.cellIndex, w))) continue;
if (O.weight <= t.ColumnWeight) {
this.getWrittenCellsPalace(T.cellIndex, w, O.haveRow, O.haveColumn);
return this;
}
(L = new u()).cellIndex = T.cellIndex;
L.num = w;
L.weight = O.weight;
L.rowNum = O.haveRow;
L.columnNum = O.haveColumn;
L.type = 0;
y.push(L);
}
} catch (e) {
o = {
error: e
};
} finally {
try {
S && !S.done && (r = x.return) && r.call(x);
} finally {
if (o) throw o.error;
}
}
}
} catch (t) {
e = {
error: t
};
} finally {
try {
v && !v.done && (l = m.return) && l.call(m);
} finally {
if (e) throw e.error;
}
}
}
for (p = 0; p < 9; p++) {
var g = this.getCellNotes(this.sudoku.rowCells[p]);
b = this.hideCombination(g, 1);
try {
for (var N = (n = void 0, __values(b)), R = N.next(); !R.done; R = N.next()) {
w = R.value;
try {
for (var _ = (i = void 0, __values(this.sudoku.rowCells[p])), P = _.next(); !P.done; P = _.next()) if ((T = P.value).notes.length > 0 && -1 != T.notes.indexOf(w)) {
if (null == (O = this.getWrittenCellsWeight(T.cellIndex, w))) continue;
if (O.weight <= t.ColumnWeight) {
this.getWrittenCells(T.cellIndex, w, O.havePalace, O.haveColumn);
return this;
}
(L = new u()).cellIndex = T.cellIndex;
L.num = w;
L.weight = O.weight;
L.type = 1;
L.plaseNum = O.havePalace;
L.columnNum = O.haveColumn;
y.push(L);
}
} catch (e) {
i = {
error: e
};
} finally {
try {
P && !P.done && (a = _.return) && a.call(_);
} finally {
if (i) throw i.error;
}
}
}
} catch (e) {
n = {
error: e
};
} finally {
try {
R && !R.done && (s = N.return) && s.call(N);
} finally {
if (n) throw n.error;
}
}
}
for (p = 0; p < 9; p++) {
C = this.getCellNotes(this.sudoku.columnCells[p]), b = this.hideCombination(C, 1);
try {
for (var I = (c = void 0, __values(b)), A = I.next(); !A.done; A = I.next()) {
w = A.value;
try {
for (var k = (d = void 0, __values(this.sudoku.columnCells[p])), E = k.next(); !E.done; E = k.next()) {
var T;
if ((T = E.value).notes.length > 0 && -1 != T.notes.indexOf(w)) {
var O, L;
if (null == (O = this.getWrittenCellsColumnWeight(T.cellIndex, w))) continue;
if (O.weight <= t.ColumnWeight) {
this.getWrittenCellsColumn(T.cellIndex, w, O.havePalace, O.haveRow);
return this;
}
(L = new u()).cellIndex = T.cellIndex;
L.num = w;
L.weight = O.weight;
L.type = 2;
L.plaseNum = O.havePalace;
L.rowNum = O.haveRow;
y.push(L);
}
}
} catch (e) {
d = {
error: e
};
} finally {
try {
E && !E.done && (f = k.return) && f.call(k);
} finally {
if (d) throw d.error;
}
}
}
} catch (e) {
c = {
error: e
};
} finally {
try {
A && !A.done && (h = I.return) && h.call(I);
} finally {
if (c) throw c.error;
}
}
}
console.log("allAns =", y);
if (0 == y.length) return null;
var F = 0, j = 0;
for (p = 0; p < y.length; p++) {
var q = y[p];
if (0 == j) j = q.weight; else if (q.weight < j) {
j = q.weight;
F = p;
}
}
var D = y[F];
if (0 === D.type) {
this.getWrittenCellsPalace(D.cellIndex, D.num, D.rowNum, D.columnNum);
return this;
}
if (1 === D.type) {
this.getWrittenCells(D.cellIndex, D.num, D.plaseNum, D.columnNum);
return this;
}
this.getWrittenCellsColumn(D.cellIndex, D.num, D.plaseNum, D.rowNum);
return this;
};
t.prototype.getWrittenCells = function(e, t, l, r) {
for (var n, i, a, u, c, h, d = this.sudoku.rowCells[this.sudoku.cells[e].rowIndex], f = [], y = 0; y < l.length; y++) f = f.concat(this.sudoku.palaceCells[l[y]].filter(function(e) {
return e.questionOrAnswer == t;
}));
for (y = 0; y < r.length; y++) f = f.concat(this.sudoku.columnCells[r[y]].filter(function(e) {
return e.questionOrAnswer == t;
}));
this.relationRows = [ this.sudoku.cells[e].rowIndex ];
var p = d.filter(function(t) {
return t.cellIndex != e && 0 == t.questionOrAnswer;
}), C = function(l) {
var r, n;
if (0 == f.filter(function(e) {
return e.rowIndex == l.rowIndex || e.columnIndex == l.columnIndex || e.palaceIndex == l.palaceIndex;
}).length) {
b.name = "隐性唯一候选数法";
b.supplySystemNotes([ d ]);
try {
for (var i = (r = void 0, __values(d)), a = i.next(); !a.done; a = i.next()) {
var u = a.value;
if (u.notes.length > 0 && -1 != u.notes.indexOf(t) && t == u.right) {
var c = new o();
c.bindCell = u;
c.notesStress = [ t ];
c.style = o.STYLE_AFFECTED;
c.numWrite = t;
b.relationCells.push(c);
b.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + b.rowNumberToLetter(b.sudoku.cells[e].rowIndex) + "</color></b> 行中，候选数 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 仅出现在 <b><color=" + s.AffectedCellStyle + ">" + u.coordinate + "</color></b> 中，那么 <b><color=" + s.AffectedCellStyle + ">" + u.coordinate + "</color></b> 答案应当填 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 。";
b.getStep();
return {
value: b
};
}
}
} catch (e) {
r = {
error: e
};
} finally {
try {
a && !a.done && (n = i.return) && n.call(i);
} finally {
if (r) throw r.error;
}
}
}
}, b = this;
try {
for (var m = __values(p), v = m.next(); !v.done; v = m.next()) {
var w = C(g = v.value);
if ("object" == typeof w) return w.value;
}
} catch (e) {
n = {
error: e
};
} finally {
try {
v && !v.done && (i = m.return) && i.call(m);
} finally {
if (n) throw n.error;
}
}
try {
for (var x = __values(f), S = x.next(); !S.done; S = x.next()) {
var g = S.value;
(E = new o()).bindCell = g;
E.style = o.STYLE_REFER;
E.numIsStress = !0;
this.relationCells.push(E);
}
} catch (e) {
a = {
error: e
};
} finally {
try {
S && !S.done && (u = x.return) && u.call(x);
} finally {
if (a) throw a.error;
}
}
var N = new o();
N.bindCell = this.sudoku.cells[e];
N.numWrite = t;
N.remindNum = t;
N.style = o.STYLE_AFFECTED;
this.influenceRCP = [ [], r, l ];
this.relationCells.push(N);
var R = __read(this.getRCPStr(this.influenceRCP), 2), _ = R[0], P = R[1], I = _.join("、");
try {
for (var A = __values(p), k = A.next(); !k.done; k = A.next()) {
var E;
g = k.value;
(E = new o()).bindCell = g;
E.style = o.STYLE_EXCLUDE;
this.relationCells.push(E);
}
} catch (e) {
c = {
error: e
};
} finally {
try {
k && !k.done && (h = A.return) && h.call(A);
} finally {
if (c) throw c.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.sudoku.cells[e].rowIndex) + "</color></b> 行中，因" + I + "包含数字 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b>，那么仅剩余 <b><color=" + s.AffectedCellStyle + ">" + this.sudoku.cells[e].coordinate + "</color></b> 可以填 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 。";
this.stressColumn = this.relationColumn;
this.stressPalace = this.relationPalace;
this.relationColumn = this.relationPalace = [];
this.findStep(I, P, e, t);
};
t.prototype.getWrittenCellsWeight = function(e, l) {
for (var o = this.sudoku.rowCells[this.sudoku.cells[e].rowIndex].filter(function(t) {
return 0 >= t.questionOrAnswer && t.cellIndex != e;
}), r = [], n = []; o.length > 0; ) {
var s = this.getOneColumnOrPalase(o, l);
if (o.length == s.rowsNoQuestion.length) return null;
console.log(o.length);
o = s.rowsNoQuestion;
s.haveColumn >= 0 && r.push(s.haveColumn);
s.havePalace >= 0 && n.push(s.havePalace);
}
var i = n.length * t.PlaseWeight + r.length * t.ColumnWeight;
return {
cellIndex: e,
num: l,
weight: i,
haveColumn: r,
havePalace: n
};
};
t.prototype.getOneColumnOrPalase = function(e, t) {
var l, o, r = -1, n = -1, s = [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ], i = [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
try {
for (var a = __values(e), u = a.next(); !u.done; u = a.next()) {
var c = u.value;
0 == s[c.columnIndex] ? this.sudoku.columnCells[c.columnIndex].filter(function(e) {
return t == e.questionOrAnswer;
}).length > 0 && s[c.columnIndex]++ : s[c.columnIndex]++;
0 == i[c.palaceIndex] ? this.sudoku.palaceCells[c.palaceIndex].filter(function(e) {
return t == e.questionOrAnswer;
}).length > 0 && i[c.palaceIndex]++ : i[c.palaceIndex]++;
}
} catch (e) {
l = {
error: e
};
} finally {
try {
u && !u.done && (o = a.return) && o.call(a);
} finally {
if (l) throw l.error;
}
}
for (var h = 0, d = 0, f = 0; f < s.length; f++) if ((C = s[f]) > h) {
h = C;
d = f;
}
var y = 0, p = 0;
for (f = 0; f < i.length; f++) {
var C;
if ((C = i[f]) > y) {
y = C;
p = f;
}
}
var b = [];
if (h >= y) {
r = d;
b = e.filter(function(e) {
return d != e.columnIndex;
});
} else {
n = p;
b = e.filter(function(e) {
return p != e.palaceIndex;
});
}
return {
rowsNoQuestion: b,
haveColumn: r,
havePalace: n
};
};
t.prototype.getRCPStr = function(e) {
var t = [], l = [];
if (e[0].length > 0) for (var o = 0; o < e[0].length; o++) {
t.push("第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(e[0][o]) + "</color></b> 行");
l.push({
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(e[0][o]) + "</color></b>"
});
this.relationRows.push(e[0][o]);
}
if (e[1].length > 0) for (o = 0; o < e[1].length; o++) {
t.push("第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e[1][o] + 1) + "</color></b> 列");
l.push({
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e[1][o] + 1) + "</color></b>"
});
this.relationColumn.push(e[1][o]);
}
if (e[2].length > 0) for (o = 0; o < e[2].length; o++) {
t.push("第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e[2][o] + 1) + "</color></b> 宫");
l.push({
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e[2][o] + 1) + "</color></b>"
});
this.relationPalace.push(e[2][o]);
}
return [ t, l ];
};
t.prototype.getWrittenCellsColumn = function(e, t, l, r) {
for (var n, i, a, u, c, h, d = this.sudoku.columnCells[this.sudoku.cells[e].columnIndex], f = [], y = 0; y < l.length; y++) f = f.concat(this.sudoku.palaceCells[l[y]].filter(function(e) {
return e.questionOrAnswer == t;
}));
for (y = 0; y < r.length; y++) f = f.concat(this.sudoku.rowCells[r[y]].filter(function(e) {
return e.questionOrAnswer == t;
}));
this.relationColumn = [ this.sudoku.cells[e].columnIndex ];
var p = d.filter(function(t) {
return t.cellIndex != e && 0 == t.questionOrAnswer;
}), C = function(l) {
var r, n;
if (0 == f.filter(function(e) {
return e.rowIndex == l.rowIndex || e.columnIndex == l.columnIndex || e.palaceIndex == l.palaceIndex;
}).length) {
b.name = "隐性唯一候选数法";
b.supplySystemNotes([ d ]);
try {
for (var i = (r = void 0, __values(d)), a = i.next(); !a.done; a = i.next()) {
var u = a.value;
if (u.notes.length > 0 && -1 != u.notes.indexOf(t) && t == u.right) {
var c = new o();
c.bindCell = u;
c.notesStress = [ t ];
c.style = o.STYLE_AFFECTED;
c.numWrite = t;
b.relationCells.push(c);
b.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (b.sudoku.cells[e].columnIndex + 1) + "</color></b> 列中，候选数 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 仅出现在 <b><color=" + s.AffectedCellStyle + ">" + u.coordinate + "</color></b> 中，那么 <b><color=" + s.AffectedCellStyle + ">" + u.coordinate + "</color></b> 答案应当填 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 。";
b.getStep();
return {
value: b
};
}
}
} catch (e) {
r = {
error: e
};
} finally {
try {
a && !a.done && (n = i.return) && n.call(i);
} finally {
if (r) throw r.error;
}
}
}
}, b = this;
try {
for (var m = __values(p), v = m.next(); !v.done; v = m.next()) {
var w = C(g = v.value);
if ("object" == typeof w) return w.value;
}
} catch (e) {
n = {
error: e
};
} finally {
try {
v && !v.done && (i = m.return) && i.call(m);
} finally {
if (n) throw n.error;
}
}
try {
for (var x = __values(f), S = x.next(); !S.done; S = x.next()) {
var g = S.value;
(E = new o()).bindCell = g;
E.style = o.STYLE_REFER;
E.numIsStress = !0;
this.relationCells.push(E);
}
} catch (e) {
a = {
error: e
};
} finally {
try {
S && !S.done && (u = x.return) && u.call(x);
} finally {
if (a) throw a.error;
}
}
var N = new o();
N.bindCell = this.sudoku.cells[e];
N.numWrite = t;
N.remindNum = t;
N.style = o.STYLE_AFFECTED;
this.relationCells.push(N);
this.influenceRCP = [ r, [], l ];
var R = __read(this.getRCPStr(this.influenceRCP), 2), _ = R[0], P = R[1], I = _.join("、");
try {
for (var A = __values(p), k = A.next(); !k.done; k = A.next()) {
var E;
g = k.value;
(E = new o()).bindCell = g;
E.style = o.STYLE_EXCLUDE;
this.relationCells.push(E);
}
} catch (e) {
c = {
error: e
};
} finally {
try {
k && !k.done && (h = A.return) && h.call(A);
} finally {
if (c) throw c.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.sudoku.cells[e].columnIndex + 1) + "</color></b> 列中，因" + I + "包含数字 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b>，那么仅剩余 <b><color=" + s.AffectedCellStyle + ">" + this.sudoku.cells[e].coordinate + "</color></b> 可以填 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 。";
this.stressRows = this.relationRows;
this.stressPalace = this.relationPalace;
this.relationRows = this.relationPalace = [];
this.findStep(I, P, e, t);
};
t.prototype.getWrittenCellsColumnWeight = function(e, l) {
for (var o, r = this.sudoku.columnCells[this.sudoku.cells[e].columnIndex].filter(function(t) {
return 0 >= t.questionOrAnswer && t.cellIndex != e;
}), n = [], s = []; r.length > 0; ) {
var i = this.getOneRowOrPlase(r, l);
if (r.length == i.columnsNoQuestion.length) return null;
r = i.columnsNoQuestion;
i.haveRow >= 0 && s.push(i.haveRow);
i.havePalace >= 0 && n.push(i.havePalace);
}
o = n.length * t.PlaseWeight + s.length * t.RowWeight;
return {
cellIndex: e,
num: l,
weight: o,
havePalace: n,
haveRow: s
};
};
t.prototype.getOneRowOrPlase = function(e, t) {
var l, o, r = -1, n = -1, s = [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ], i = [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
try {
for (var a = __values(e), u = a.next(); !u.done; u = a.next()) {
var c = u.value;
0 == s[c.rowIndex] ? this.sudoku.rowCells[c.rowIndex].filter(function(e) {
return t == e.questionOrAnswer;
}).length > 0 && s[c.rowIndex]++ : s[c.rowIndex]++;
0 == i[c.palaceIndex] ? this.sudoku.palaceCells[c.palaceIndex].filter(function(e) {
return t == e.questionOrAnswer;
}).length > 0 && i[c.palaceIndex]++ : i[c.palaceIndex]++;
}
} catch (e) {
l = {
error: e
};
} finally {
try {
u && !u.done && (o = a.return) && o.call(a);
} finally {
if (l) throw l.error;
}
}
for (var h = 0, d = 0, f = 0; f < s.length; f++) if ((C = s[f]) > h) {
h = C;
d = f;
}
var y = 0, p = 0;
for (f = 0; f < i.length; f++) {
var C;
if ((C = i[f]) > y) {
y = C;
p = f;
}
}
var b = [];
if (h >= y) {
r = d;
b = e.filter(function(e) {
return d != e.rowIndex;
});
} else {
n = p;
b = e.filter(function(e) {
return p != e.palaceIndex;
});
}
return {
columnsNoQuestion: b,
haveRow: r,
havePalace: n
};
};
t.prototype.findStep = function(e, t, l, i) {
var a, u, c, h, d, f = [], y = "";
if (this.relationColumn.length > 0) {
y = "<b><color=" + s.tipsNumStyle + ">" + (this.relationColumn[0] + 1) + "</color></b> 列";
d = {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b>"
};
} else if (this.relationRows.length > 0) {
y = "<b><color=" + s.tipsNumStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b> 行";
d = {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b>"
};
} else if (this.relationPalace.length > 0) {
y = "<b><color=" + s.tipsNumStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫";
d = {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
};
}
this.descKey = "bcf0";
this.descData = [ [ d ], t, "<b><color=" + s.tipsNumStyle + ">" + i + "</color></b>", "<b><color=" + s.AffectedCellStyle + ">" + this.sudoku.cells[l].coordinate + "</color></b>" ];
var p = new r();
p.relationColumn = this.relationColumn;
p.relationRows = this.relationRows;
p.relationPalace = this.relationPalace;
try {
for (var C = __values(this.relationCells), b = C.next(); !b.done; b = C.next()) if ((x = b.value).style == o.STYLE_REFER) {
p.relationCells.push(x);
f.push(" <b><color=" + s.tipsNumStyle + ">" + x.bindCell.coordinate + "</color></b> ");
}
} catch (e) {
a = {
error: e
};
} finally {
try {
b && !b.done && (u = C.return) && u.call(C);
} finally {
if (a) throw a.error;
}
}
p.desc = "留意单元格" + f.join("、") + "，以及突出显示的第 " + y + "。";
p.descKey = "bcf1";
p.descData = [ f.join("、"), [ d ] ];
var m = this.clone(p);
m.noFrameColumn = this.relationColumn;
m.noFrameRows = this.relationRows;
m.noFramePalace = this.relationPalace;
m.relationColumn = m.relationRows = m.relationPalace = [];
m.stressRows = this.stressRows;
m.stressColumn = this.stressColumn;
m.stressPalace = this.stressPalace;
try {
for (var v = __values(this.relationCells), w = v.next(); !w.done; w = v.next()) {
var x;
(x = w.value).style == o.STYLE_EXCLUDE && m.relationCells.push(x);
}
} catch (e) {
c = {
error: e
};
} finally {
try {
w && !w.done && (h = v.return) && h.call(v);
} finally {
if (c) throw c.error;
}
}
for (var S = [], g = function(e) {
S.push([ m.relationCells.filter(function(t) {
return t.bindCell.rowIndex == m.stressRows[e];
}), [ m.stressRows[e], -1, -1 ] ]);
}, N = 0; N < m.stressRows.length; N++) g(N);
var R = function(e) {
S.push([ m.relationCells.filter(function(t) {
return t.bindCell.columnIndex == m.stressColumn[e];
}), [ -1, m.stressColumn[e], -1 ] ]);
};
for (N = 0; N < m.stressColumn.length; N++) R(N);
var _ = function(e) {
S.push([ m.relationCells.filter(function(t) {
return t.bindCell.palaceIndex == m.stressPalace[e];
}), [ -1, -1, m.stressPalace[e] ] ]);
};
for (N = 0; N < m.stressPalace.length; N++) _(N);
var P;
P = this.relationRows.length > 0 ? "ColumnIndex" : "rowIndex";
S = this.sortSubRelationCell(S, P);
for (var N in S) {
var I = new n();
I.remindRows = S[N][1][0] >= 0 ? [ S[N][1][0] ] : [];
I.remindColumn = S[N][1][1] >= 0 ? [ S[N][1][1] ] : [];
I.remindPalace = S[N][1][2] >= 0 ? [ S[N][1][2] ] : [];
I.relationCells = S[N][0];
m.subStep.push(I);
}
m.desc = e + "中已包含数字 <b><color=" + s.tipsNumStyle + ">" + i + "</color></b> ，所以打 <b><color=" + s.tipsNumStyle + ">X</color></b> 的单元格不能包含数字 <b><color=" + s.tipsNumStyle + ">" + i + "</color></b> 。";
m.descKey = "bcf2";
m.descData = [ t, "<b><color=" + s.tipsNumStyle + ">" + i + "</color></b>", "<b><color=" + s.tipsNumStyle + ">" + i + "</color></b>" ];
var A = this.clone(p);
m.stressRows = this.stressRows;
m.stressColumn = this.stressColumn;
m.stressPalace = this.stressPalace;
A.relationCells = this.relationCells;
A.desc = "那么第 " + y + "中仅剩余 <b><color=" + s.AffectedCellStyle + ">" + this.sudoku.cells[l].coordinate + "</color></b> 可以填 <b><color=" + s.tipsNumStyle + ">" + i + "</color></b> 。";
A.descKey = "bcf3";
A.descData = [ d, "<b><color=" + s.AffectedCellStyle + ">" + this.sudoku.cells[l].coordinate + "</color></b>", "<b><color=" + s.tipsNumStyle + ">" + i + "</color></b>" ];
this.step = [ p, m, A ];
};
t.prototype.sortSubRelationCell = function(e, t) {
void 0 === t && (t = "columnIndex");
var l = [], r = [];
for (var n in e) "columnIndex" == t ? r.push({
k: n,
v: e[n][0].filter(function(e) {
return e.style == o.STYLE_REFER;
})[0].bindCell.columnIndex
}) : r.push({
k: n,
v: e[n][0].filter(function(e) {
return e.style == o.STYLE_REFER;
})[0].bindCell.rowIndex
});
r.sort(function(e, t) {
return e.v - t.v;
});
for (var n in r) l.push(e[r[n].k]);
return l;
};
t.prototype.getWrittenCellsPalace = function(e, t, l, r) {
for (var n, i, a, u, c, h, d = this.sudoku.palaceCells[this.sudoku.cells[e].palaceIndex], f = [], y = 0; y < l.length; y++) f = f.concat(this.sudoku.rowCells[l[y]].filter(function(e) {
return e.questionOrAnswer == t;
}));
for (y = 0; y < r.length; y++) f = f.concat(this.sudoku.columnCells[r[y]].filter(function(e) {
return e.questionOrAnswer == t;
}));
this.relationPalace = [ this.sudoku.cells[e].palaceIndex ];
var p = d.filter(function(t) {
return t.cellIndex != e && 0 == t.questionOrAnswer;
}), C = function(l) {
var r, n;
if (0 == f.filter(function(e) {
return e.rowIndex == l.rowIndex || e.columnIndex == l.columnIndex || e.palaceIndex == l.palaceIndex;
}).length) {
b.name = "隐性唯一候选数法";
b.supplySystemNotes([ d ]);
try {
for (var i = (r = void 0, __values(d)), a = i.next(); !a.done; a = i.next()) {
var u = a.value;
if (u.notes.length > 0 && -1 != u.notes.indexOf(t) && t == u.right) {
var c = new o();
c.bindCell = u;
c.notesStress = [ t ];
c.style = o.STYLE_AFFECTED;
c.numWrite = t;
b.relationCells.push(c);
b.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (b.sudoku.cells[e].palaceIndex + 1) + "</color></b> 宫中，候选数 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 仅出现在 <b><color=" + s.AffectedCellStyle + ">" + u.coordinate + "</color></b> 中，那么 <b><color=" + s.AffectedCellStyle + ">" + u.coordinate + "</color></b> 答案应当填 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 。";
b.getStep();
return {
value: b
};
}
}
} catch (e) {
r = {
error: e
};
} finally {
try {
a && !a.done && (n = i.return) && n.call(i);
} finally {
if (r) throw r.error;
}
}
}
}, b = this;
try {
for (var m = __values(p), v = m.next(); !v.done; v = m.next()) {
var w = C(g = v.value);
if ("object" == typeof w) return w.value;
}
} catch (e) {
n = {
error: e
};
} finally {
try {
v && !v.done && (i = m.return) && i.call(m);
} finally {
if (n) throw n.error;
}
}
try {
for (var x = __values(f), S = x.next(); !S.done; S = x.next()) {
var g = S.value;
(E = new o()).bindCell = g;
E.style = o.STYLE_REFER;
E.numIsStress = !0;
this.relationCells.push(E);
}
} catch (e) {
a = {
error: e
};
} finally {
try {
S && !S.done && (u = x.return) && u.call(x);
} finally {
if (a) throw a.error;
}
}
var N = new o();
N.bindCell = this.sudoku.cells[e];
N.numWrite = t;
N.remindNum = t;
N.style = o.STYLE_AFFECTED;
this.relationCells.push(N);
this.influenceRCP = [ l, r, [] ];
var R = __read(this.getRCPStr(this.influenceRCP), 2), _ = R[0], P = R[1], I = _.join("、");
try {
for (var A = __values(p), k = A.next(); !k.done; k = A.next()) {
var E;
g = k.value;
(E = new o()).bindCell = g;
E.style = o.STYLE_EXCLUDE;
this.relationCells.push(E);
}
} catch (e) {
c = {
error: e
};
} finally {
try {
k && !k.done && (h = A.return) && h.call(A);
} finally {
if (c) throw c.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.sudoku.cells[e].palaceIndex + 1) + "</color></b> 宫中，因" + I + "包含数字 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b>，那么仅剩余 <b><color=" + s.AffectedCellStyle + ">" + this.sudoku.cells[e].coordinate + "</color></b> 可以填 <b><color=" + s.tipsNumStyle + ">" + t + "</color></b> 。";
this.stressRows = this.relationRows;
this.stressColumn = this.relationColumn;
this.relationRows = this.relationColumn = [];
this.findStep(I, P, e, t);
};
t.prototype.getWrittenCellsPalaceWeight = function(e, l) {
for (var o = this.sudoku.palaceCells[this.sudoku.cells[e].palaceIndex].filter(function(t) {
return 0 >= t.questionOrAnswer && t.cellIndex != e;
}), r = [], n = []; o.length > 0; ) {
var s = this.getOneRowOrColumn(o, l);
if (o.length == s.palaceNoQuestion.length) return null;
o = s.palaceNoQuestion;
s.haveRow >= 0 && n.push(s.haveRow);
s.haveColumn >= 0 && r.push(s.haveColumn);
}
var i = r.length * t.ColumnWeight + n.length * t.RowWeight;
return {
cellIndex: e,
num: l,
weight: i,
haveColumn: r,
haveRow: n
};
};
t.prototype.getOneRowOrColumn = function(e, t) {
var l, o, r = -1, n = -1, s = [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ], i = [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
try {
for (var a = __values(e), u = a.next(); !u.done; u = a.next()) {
var c = u.value;
0 == s[c.rowIndex] ? this.sudoku.rowCells[c.rowIndex].filter(function(e) {
return t == e.questionOrAnswer;
}).length > 0 && s[c.rowIndex]++ : s[c.rowIndex]++;
0 == i[c.columnIndex] ? this.sudoku.columnCells[c.columnIndex].filter(function(e) {
return t == e.questionOrAnswer;
}).length > 0 && i[c.columnIndex]++ : i[c.columnIndex]++;
}
} catch (e) {
l = {
error: e
};
} finally {
try {
u && !u.done && (o = a.return) && o.call(a);
} finally {
if (l) throw l.error;
}
}
for (var h = 0, d = 0, f = 0; f < s.length; f++) if ((C = s[f]) > h) {
h = C;
d = f;
}
var y = 0, p = 0;
for (f = 0; f < i.length; f++) {
var C;
if ((C = i[f]) > y) {
y = C;
p = f;
}
}
var b = [];
if (h >= y) {
n = d;
b = e.filter(function(e) {
return d != e.rowIndex;
});
} else {
r = p;
b = e.filter(function(e) {
return p != e.columnIndex;
});
}
return {
palaceNoQuestion: b,
haveRow: n,
haveColumn: r
};
};
t.RowWeight = 1;
t.ColumnWeight = 1.1;
t.PlaseWeight = 3.5;
return t;
}(s);
e.HideNumOne1 = c;
var h = function(t) {
__extends(l, t);
function l() {
var e = null !== t && t.apply(this, arguments) || this;
e.name = "显性N候选数法";
e.num = 2;
e.strarr = {
2: "二",
3: "三",
4: "四"
};
return e;
}
l.prototype.find = function(t) {
var l, o, r, n, i, a;
this.num = t;
var u = this.strarr;
this.name = "显式" + u[t] + "数集删减法";
for (var c = 0; c < 9; c++) {
var h = this.getCellNotes(this.sudoku.rowCells[c]);
if ((S = this.explicitCombination(h, t)).length > 0) for (var d = 0; d < S.length; d++) if (this.getWrittenCells(this.sudoku.rowCells[c], S[d])) {
this.relationRows = [ c ];
var f = [], y = [];
try {
for (var p = (l = void 0, __values(this.relationCells)), C = p.next(); !C.done; C = p.next()) {
var b = C.value;
b.style == e.AnalysisCell.STYLE_RELATION && f.push("<b><color=" + s.tipsCellStyle + ">" + b.bindCell.coordinate + "</color></b>");
b.style == e.AnalysisCell.STYLE_AFFECTED && y.push("<b><color=" + s.tipsCellStyle + ">" + b.bindCell.coordinate + "</color></b>");
}
} catch (e) {
l = {
error: e
};
} finally {
try {
C && !C.done && (o = p.return) && o.call(p);
} finally {
if (l) throw l.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(c) + "</color></b> 行中，" + f.join("、") + " 只包含候选数 " + S[d].map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、") + "，那么 " + y.join("、") + " 中的可以删除。";
this.findstep(S[d]);
return this;
}
}
for (c = 0; c < 9; c++) {
var m = this.getCellNotes(this.sudoku.palaceCells[c]);
if ((S = this.explicitCombination(m, t)).length > 0) for (d = 0; d < S.length; d++) if (this.getWrittenCells(this.sudoku.palaceCells[c], S[d])) {
this.relationPalace = [ c ];
f = [], y = [];
try {
for (var v = (r = void 0, __values(this.relationCells)), w = v.next(); !w.done; w = v.next()) {
var x = w.value;
x.style == e.AnalysisCell.STYLE_RELATION && f.push("<b><color=" + s.tipsCellStyle + ">" + x.bindCell.coordinate + "</color></b>");
x.style == e.AnalysisCell.STYLE_AFFECTED && y.push("<b><color=" + s.AffectedCellStyle + ">" + x.bindCell.coordinate + "</color></b>");
}
} catch (e) {
r = {
error: e
};
} finally {
try {
w && !w.done && (n = v.return) && n.call(v);
} finally {
if (r) throw r.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (c + 1) + "</color></b> 宫中，" + f.join("、") + " 只包含候选数 " + S[d].map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、") + "，那么 " + y.join("、") + " 中的可以删除。";
this.findstep(S[d]);
return this;
}
}
for (c = 0; c < 9; c++) {
var S, g = this.getCellNotes(this.sudoku.columnCells[c]);
if ((S = this.explicitCombination(g, t)).length > 0) for (d = 0; d < S.length; d++) if (this.getWrittenCells(this.sudoku.columnCells[c], S[d])) {
this.relationColumn = [ c ];
f = [], y = [];
try {
for (var N = (i = void 0, __values(this.relationCells)), R = N.next(); !R.done; R = N.next()) {
var _ = R.value;
_.style == e.AnalysisCell.STYLE_RELATION && f.push("<b><color=" + s.tipsCellStyle + ">" + _.bindCell.coordinate + "</color></b>");
_.style == e.AnalysisCell.STYLE_AFFECTED && y.push("<b><color=" + s.AffectedCellStyle + ">" + _.bindCell.coordinate + "</color></b>");
}
} catch (e) {
i = {
error: e
};
} finally {
try {
R && !R.done && (a = N.return) && a.call(N);
} finally {
if (i) throw i.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (c + 1) + "</color></b> 列中，" + f.join("、") + " 只包含候选数 " + S[d].map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、") + "，那么 " + y.join("、") + " 中的可以删除。";
this.findstep(S[d]);
return this;
}
}
return null;
};
l.prototype.findstep = function(t) {
var l, o, i = __read([ [], [], [], [] ], 4), a = i[0], u = i[1], c = i[2], h = i[3];
try {
for (var d = __values(this.relationCells), f = d.next(); !f.done; f = d.next()) {
var y = f.value;
if (y.style == e.AnalysisCell.STYLE_RELATION) {
a.push("<b><color=" + s.tipsCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
c.push(this.clone(y));
}
if (y.style == e.AnalysisCell.STYLE_AFFECTED) {
u.push("<b><color=" + s.AffectedCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
h.push(this.clone(y));
}
}
} catch (e) {
l = {
error: e
};
} finally {
try {
f && !f.done && (o = d.return) && o.call(d);
} finally {
if (l) throw l.error;
}
}
var p, C = "";
if (this.relationColumn.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b> 列";
p = {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b>"
};
} else if (this.relationRows.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b> 行";
p = {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b>"
};
} else if (this.relationPalace.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫";
p = {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
};
}
var b = [], m = t.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
});
b[0] = m.slice(0, m.length - 1).join("、");
b[1] = m.slice(m.length - 1);
var v = [];
v[0] = a.slice(0, a.length - 1).join("、");
v[1] = a.slice(a.length - 1);
var w = [];
if (u.length > 1) {
w[0] = u.slice(0, u.length - 1).join("、");
w[1] = u.slice(u.length - 1);
} else w = u;
this.descKey = "xssj0";
this.descData = [ [ p ], a.join("、"), t.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、"), u.join("、") ];
var x = new r();
x.noFrameRows = this.relationRows;
x.noFrameColumn = this.relationColumn;
x.noFramePalace = this.relationPalace;
x.supplyIndex = this.supplyIndex;
x.supplyNotes = this.supplyNotes;
x.relationCells = this.clone(c);
var S = new n();
S.relationRows = this.relationRows;
S.relationColumn = this.relationColumn;
S.relationPalace = this.relationPalace;
x.subStep.push(S);
x.desc = "留意" + C + "，以及这些区域出现的数字";
x.descKey = "xxwyhxs1";
x.descData = [ [ p ] ];
var g = new r();
g.relationRows = this.relationRows;
g.relationColumn = this.relationColumn;
g.relationPalace = this.relationPalace;
g.supplyIndex = this.supplyIndex;
g.supplyNotes = this.supplyNotes;
g.relationCells = this.clone(c);
var N = new n();
N.relationCells = this.clone(c);
N.relationCells.map(function(e) {
return e.notesStress = e.bindCell.userNotes.length > 0 ? e.bindCell.userNotes : e.bindCell.systemNotes;
});
g.subStep.push(N);
g.desc = "单元格 " + v.join(" 和 ") + " 中只出现数字 " + b.join(" 和 ") + "，那么这" + ("二" == this.strarr[this.num] ? "两" : this.strarr[this.num]) + "个单元格答案必然为 " + b.join(" 或 ") + "。";
g.descKey = "xssj" + this.num;
g.descData = [ a.join("、"), t.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、"), b[0], b[1][0] ];
var R = new r();
R.relationRows = this.relationRows;
R.relationColumn = this.relationColumn;
R.relationPalace = this.relationPalace;
R.supplyIndex = this.supplyIndex;
R.supplyNotes = this.supplyNotes;
R.relationCells = this.clone(this.relationCells);
var _ = new n();
_.relationCells = h;
R.subStep.push(_);
R.desc = "单元格 " + w.join(" 和 ") + " 中的 " + b.join(" 和 ").replace(/Road.tipsNumStyle/, s.delNumStyle) + " 就需要删除了。";
R.descKey = "xssj1";
R.descData = [ u.join("、"), t.map(function(e) {
return "<b><color=" + s.delNumStyle + ">" + e + "</color></b>";
}).join("、") ];
this.step = [ x, g, R ];
};
l.prototype.getWrittenCells = function(e, t) {
var l, r, n = !1, s = !1, i = [];
try {
for (var a = __values(e), u = a.next(); !u.done; u = a.next()) {
var c = u.value;
if (c.notes.length > 0) {
for (var h = [], d = [], f = 0; f < c.notes.length; f++) -1 == t.indexOf(c.notes[f]) ? d.push(c.notes[f]) : h.push(c.notes[f]);
var y = new o();
y.bindCell = c;
y.numIsStress = !1;
if (0 == d.length) {
n = !0;
y.style = o.STYLE_RELATION;
i.push(y);
} else if (d.length > 0 && h.length > 0) {
s = !0;
y.style = o.STYLE_AFFECTED;
y.notesRemove = h;
i.push(y);
}
}
}
} catch (e) {
l = {
error: e
};
} finally {
try {
u && !u.done && (r = a.return) && r.call(a);
} finally {
if (l) throw l.error;
}
}
if (n && s) {
this.relationCells = i;
this.supplySystemNotes([ e ]);
return !0;
}
return !1;
};
l.prototype.explicitCombination = function(e, t) {
void 0 === t && (t = 5);
var l = [];
if (e.length <= t) return [];
for (var o = e.length, r = Math.pow(2, o), n = Math.pow(2, t) - 1; n < r; n++) {
for (var s = 0, i = [], a = 0; a < o; a++) {
var u = Math.pow(2, a);
if ((n & u) == u) {
i.push(e[a]);
s++;
}
}
if (s == t) {
var c = this.mergerUniqueArr(i);
c.length == t && l.push(c);
}
}
return l.length > 0 ? l : [];
};
return l;
}(s);
e.ShowNumberSet = h;
var d = function(t) {
__extends(l, t);
function l() {
var e = null !== t && t.apply(this, arguments) || this;
e.name = "隐式N候选数法";
e.num = 2;
e.strarr = {
2: "二",
3: "三",
4: "四"
};
return e;
}
l.prototype.find = function(e) {
var t, l, o, r, n, i;
this.num = e;
var a = this.strarr;
this.name = "隐式" + a[e] + "数集删减法";
for (var u = 0; u < 9; u++) {
var c = this.getCellNotes(this.sudoku.rowCells[u]);
if ((v = this.hideCombination(c, e)).length > 0 && this.getWrittenCells(this.sudoku.rowCells[u], v)) {
this.relationRows = [ u ];
var h = [];
try {
for (var d = (t = void 0, __values(this.relationCells)), f = d.next(); !f.done; f = d.next()) {
var y = f.value;
h.push("<b><color=" + s.tipsCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
}
} catch (e) {
t = {
error: e
};
} finally {
try {
f && !f.done && (l = d.return) && l.call(d);
} finally {
if (t) throw t.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(u) + "</color></b> 行中，候选数 " + v.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、") + " 只出现在 " + h.join("、") + " 中，那么这" + ("二" == a[e] ? "两" : a[e]) + "个单元格的其他候选数可以删除。";
this.findstep(v);
return this;
}
}
for (u = 0; u < 9; u++) {
var p = this.getCellNotes(this.sudoku.columnCells[u]);
if ((v = this.hideCombination(p, e)).length > 0 && this.getWrittenCells(this.sudoku.columnCells[u], v)) {
this.relationColumn = [ u ];
h = [];
try {
for (var C = (o = void 0, __values(this.relationCells)), b = C.next(); !b.done; b = C.next()) {
var m = b.value;
h.push("<b><color=" + s.tipsCellStyle + ">" + m.bindCell.coordinate + "</color></b>");
}
} catch (e) {
o = {
error: e
};
} finally {
try {
b && !b.done && (r = C.return) && r.call(C);
} finally {
if (o) throw o.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (u + 1) + "</color></b> 列中，候选数 " + v.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、") + " 只出现在 " + h.join("、") + " 中，那么这" + ("二" == a[e] ? "两" : a[e]) + "个单元格的其他候选数可以删除。";
this.findstep(v);
return this;
}
}
for (u = 0; u < 9; u++) {
var v, w = this.getCellNotes(this.sudoku.palaceCells[u]);
if ((v = this.hideCombination(w, e)).length > 0 && this.getWrittenCells(this.sudoku.palaceCells[u], v)) {
this.relationPalace = [ u ];
h = [];
try {
for (var x = (n = void 0, __values(this.relationCells)), S = x.next(); !S.done; S = x.next()) {
var g = S.value;
h.push("<b><color=" + s.tipsCellStyle + ">" + g.bindCell.coordinate + "</color></b>");
}
} catch (e) {
n = {
error: e
};
} finally {
try {
S && !S.done && (i = x.return) && i.call(x);
} finally {
if (n) throw n.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (u + 1) + "</color></b> 宫中，候选数 " + v.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
}).join("、") + " 只出现在 " + h.join("、") + " 中，那么这" + ("二" == a[e] ? "两" : a[e]) + "个单元格的其他候选数可以删除。";
this.findstep(v);
return this;
}
}
return null;
};
l.prototype.findstep = function(t) {
var l, o, i = __read([ [], [] ], 2), a = i[0], u = i[1];
try {
for (var c = __values(this.relationCells), h = c.next(); !h.done; h = c.next()) {
var d = h.value;
if (d.style == e.AnalysisCell.STYLE_RELATION) {
a.push("<b><color=" + s.tipsCellStyle + ">" + d.bindCell.coordinate + "</color></b>");
u.push(this.clone(d));
}
}
} catch (e) {
l = {
error: e
};
} finally {
try {
h && !h.done && (o = c.return) && o.call(c);
} finally {
if (l) throw l.error;
}
}
var f, y = "";
if (this.relationColumn.length > 0) {
y = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b> 列";
f = {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b>"
};
} else if (this.relationRows.length > 0) {
y = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b> 行";
f = {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b>"
};
} else if (this.relationPalace.length > 0) {
y = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫";
f = {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
};
}
var p = [];
t = t.map(function(e) {
return "<b><color=" + s.tipsNumStyle + ">" + e + "</color></b>";
});
p[0] = t.slice(0, t.length - 1).join("、");
p[1] = t.slice(t.length - 1);
var C = [];
C[0] = a.slice(0, a.length - 1).join("、");
C[1] = a.slice(a.length - 1);
this.descKey = "yssj0" + this.num;
this.descData = [ [ f ], p[0], p[1], C[0], C[1][0] ];
var b = new r();
b.noFrameRows = this.relationRows;
b.noFrameColumn = this.relationColumn;
b.noFramePalace = this.relationPalace;
b.supplyIndex = this.supplyIndex;
b.supplyNotes = this.supplyNotes;
b.relationCells = this.clone(u);
b.relationCells.map(function(e) {
return e.notesRemove = [];
});
var m = new n();
m.relationRows = this.relationRows;
m.relationColumn = this.relationColumn;
m.relationPalace = this.relationPalace;
b.subStep.push(m);
b.desc = "留意" + y + "，以及这些区域中出现的数字。";
b.descKey = "xxwyhxs1";
b.descData = [ [ f ] ];
var v = new r();
v.relationRows = this.relationRows;
v.relationColumn = this.relationColumn;
v.relationPalace = this.relationPalace;
v.relationCells = this.clone(u);
v.relationCells.map(function(e) {
return e.notesStress = e.bindCell.notes.filter(function(t) {
return -1 == e.notesRemove.indexOf(t);
});
});
v.relationCells.map(function(e) {
return e.notesRemove = [];
});
var w = new n();
w.relationCells = v.relationCells;
v.subStep.push(w);
v.desc = "数字 " + p.join(" 和 ") + " 只出现在单元格 " + C.join(" 和 ") + " 中，那么这" + ("二" == this.strarr[this.num] ? "两" : this.strarr[this.num]) + "个单元格答案必然为 " + p.join(" 或 ") + " 。";
v.descKey = "yssj1" + this.num;
v.descData = [ p[0], p[1], C[0], C[1] ];
var x = this.clone(v);
x.subStep = [];
x.relationCells = this.clone(this.relationCells);
var S = new n();
S.relationCells = x.relationCells;
x.subStep.push(S);
x.desc = "那么 " + C.join(" 和 ") + " 中除 " + p.join(" 和 ") + " 外的其他候选数就需要删除了。";
x.descKey = "yssj3";
x.descData = [ C[0], C[1], p[0], p[1] ];
this.step = [ b, v, x ];
};
l.prototype.getWrittenCells = function(e, t) {
var l, r, n, s, i = [], a = [];
try {
for (var u = __values(e), c = u.next(); !c.done; c = u.next()) if ((f = c.value).notes.length > 0 && (y = f.notes.filter(function(e) {
return -1 == t.indexOf(e);
})).length < f.notes.length && y.length > 0) {
(p = new o()).bindCell = f;
p.numIsStress = !1;
p.style = o.STYLE_RELATION;
p.notesRemove = y;
i.push(p);
a.push(f.cellIndex);
}
} catch (e) {
l = {
error: e
};
} finally {
try {
c && !c.done && (r = u.return) && r.call(u);
} finally {
if (l) throw l.error;
}
}
if (a.length > 0) try {
for (var h = __values(e), d = h.next(); !d.done; d = h.next()) {
var f;
if ((f = d.value).notes.length > 0) {
var y;
if ((y = f.notes.filter(function(e) {
return -1 != t.indexOf(e);
})).length > 0 && -1 == a.indexOf(f.cellIndex)) {
var p;
(p = new o()).bindCell = f;
p.numIsStress = !1;
p.style = o.STYLE_RELATION;
i.push(p);
}
}
}
} catch (e) {
n = {
error: e
};
} finally {
try {
d && !d.done && (s = h.return) && s.call(h);
} finally {
if (n) throw n.error;
}
}
if (i.length > 0) {
this.supplySystemNotes([ e ]);
this.relationCells = i;
return !0;
}
return !1;
};
return l;
}(s);
e.HideNumberSet = d;
var f = function(t) {
__extends(l, t);
function l() {
var e = null !== t && t.apply(this, arguments) || this;
e.name = "区块删减法";
return e;
}
l.prototype.find = function() {
for (var t, l, o, r, n, i, a, u, c = 0; c < 9; c++) if ((C = this.getBlock(c, "column")).data.length > 0) {
this.getWrittenCells(C.data, c, C.palace, "column");
this.relationColumn = [ c ];
this.relationPalace = [ C.palace ];
this.supplySystemNotes([ this.sudoku.columnCells[c], this.sudoku.palaceCells[C.palace] ]);
var h = [], d = [];
try {
for (var f = (t = void 0, __values(this.relationCells)), y = f.next(); !y.done; y = f.next()) {
var p = y.value;
p.style == e.AnalysisCell.STYLE_RELATION && h.push("<b><color=" + s.tipsCellStyle + ">" + p.bindCell.coordinate + "</color></b>");
p.style == e.AnalysisCell.STYLE_AFFECTED && d.push("<b><color=" + s.AffectedCellStyle + ">" + p.bindCell.coordinate + "</color></b>");
}
} catch (e) {
t = {
error: e
};
} finally {
try {
y && !y.done && (l = f.return) && l.call(f);
} finally {
if (t) throw t.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (c + 1) + "</color></b> 列中，候选数 <b><color=" + s.tipsNumStyle + ">" + C.data[0] + "</color></b> 仅出现在第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (C.palace + 1) + "</color></b> 宫 " + h.join("、") + " 中，那么该宫 " + d.join("、") + " 中可以删除候选数 <b><color=" + s.delNumStyle + ">" + C.data[0] + "</color></b> 。";
this.findColumnRowStep();
return this;
}
for (c = 0; c < 9; c++) {
var C;
if ((C = this.getBlock(c, "row")).data.length > 0) {
this.getWrittenCells(C.data, c, C.palace, "row");
this.relationRows = [ c ];
this.relationPalace = [ C.palace ];
this.supplySystemNotes([ this.sudoku.rowCells[c], this.sudoku.palaceCells[C.palace] ]);
h = [], d = [];
try {
for (var b = (o = void 0, __values(this.relationCells)), m = b.next(); !m.done; m = b.next()) {
var v = m.value;
v.style == e.AnalysisCell.STYLE_RELATION && h.push("<b><color=" + s.tipsCellStyle + ">" + v.bindCell.coordinate + "</color></b>");
v.style == e.AnalysisCell.STYLE_AFFECTED && d.push("<b><color=" + s.AffectedCellStyle + ">" + v.bindCell.coordinate + "</color></b>");
}
} catch (e) {
o = {
error: e
};
} finally {
try {
m && !m.done && (r = b.return) && r.call(b);
} finally {
if (o) throw o.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(c) + "</color></b> 行中，候选数 <b><color=" + s.tipsNumStyle + ">" + C.data[0] + "</color></b> 仅出现在第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (C.palace + 1) + "</color></b> 宫 " + h.join("、") + " 中，那么该宫 " + d.join("、") + " 中可以删除候选数 <b><color=" + s.delNumStyle + ">" + C.data[0] + "</color></b> 。";
this.findColumnRowStep();
return this;
}
}
for (c = 0; c < 9; c++) {
var w = this.blockToRow(c);
if (w.data.length > 0) {
this.getBlockToRowColumnWrittenCells(w.data, w.row, c, "row");
this.relationPalace = [ c ];
this.relationRows = [ w.row ];
this.supplySystemNotes([ this.sudoku.rowCells[w.row], this.sudoku.palaceCells[c] ]);
h = [], d = [];
try {
for (var x = (n = void 0, __values(this.relationCells)), S = x.next(); !S.done; S = x.next()) {
var g = S.value;
g.style == e.AnalysisCell.STYLE_RELATION && h.push("<b><color=" + s.tipsCellStyle + ">" + g.bindCell.coordinate + "</color></b>");
g.style == e.AnalysisCell.STYLE_AFFECTED && d.push("<b><color=" + s.AffectedCellStyle + ">" + g.bindCell.coordinate + "</color></b>");
}
} catch (e) {
n = {
error: e
};
} finally {
try {
S && !S.done && (i = x.return) && i.call(x);
} finally {
if (n) throw n.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (c + 1) + "</color></b> 宫中，候选数 <b><color=" + s.tipsNumStyle + ">" + w.data[0] + "</color></b> 仅出现在第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(w.row) + "</color></b> 行 " + h.join("、") + " 中，那么该行 " + d.join("、") + " 中可以删除候选数 <b><color=" + s.delNumStyle + ">" + w.data[0] + "</color></b> 。";
this.findPalaceColumnRowStep();
return this;
}
var N = this.blockToColumn(c);
if (N.data.length > 0) {
this.getBlockToRowColumnWrittenCells(N.data, N.column, c, "column");
this.relationPalace = [ c ];
this.relationColumn = [ N.column ];
this.supplySystemNotes([ this.sudoku.columnCells[N.column], this.sudoku.palaceCells[c] ]);
h = [], d = [];
try {
for (var R = (a = void 0, __values(this.relationCells)), _ = R.next(); !_.done; _ = R.next()) {
var P = _.value;
P.style == e.AnalysisCell.STYLE_RELATION && h.push("<b><color=" + s.tipsCellStyle + ">" + P.bindCell.coordinate + "</color></b>");
P.style == e.AnalysisCell.STYLE_AFFECTED && d.push("<b><color=" + s.AffectedCellStyle + ">" + P.bindCell.coordinate + "</color></b>");
}
} catch (e) {
a = {
error: e
};
} finally {
try {
_ && !_.done && (u = R.return) && u.call(R);
} finally {
if (a) throw a.error;
}
}
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (c + 1) + "</color></b> 宫中，候选数 <b><color=" + s.tipsNumStyle + ">" + N.data[0] + "</color></b> 仅出现在第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (N.column + 1) + "</color></b> 列 " + h.join("、") + " 中，那么该列 " + d.join("、") + " 中可以删除候选数 <b><color=" + s.delNumStyle + ">" + N.data[0] + "</color></b> 。";
this.findPalaceColumnRowStep();
return this;
}
}
return null;
};
l.prototype.getBlockToRowColumnWrittenCells = function(e, t, l, r) {
var n, s, i, a;
void 0 === r && (r = "row");
var u = [], c = [];
if ("row" == r) {
u = this.sudoku.rowCells[t].filter(function(e) {
return e.palaceIndex != l;
});
c = this.sudoku.palaceCells[l];
} else {
u = this.sudoku.columnCells[t].filter(function(e) {
return e.palaceIndex != l;
});
c = this.sudoku.palaceCells[l];
}
try {
for (var h = __values(u), d = h.next(); !d.done; d = h.next()) if ((p = d.value).notes.length > 0 && -1 != p.notes.indexOf(e[0])) {
(C = new o()).bindCell = p;
C.numIsStress = !1;
C.style = o.STYLE_AFFECTED;
C.notesRemove = [ e[0] ];
this.relationCells.push(C);
}
} catch (e) {
n = {
error: e
};
} finally {
try {
d && !d.done && (s = h.return) && s.call(h);
} finally {
if (n) throw n.error;
}
}
try {
for (var f = __values(c), y = f.next(); !y.done; y = f.next()) {
var p;
if ((p = y.value).notes.length > 0 && -1 != p.notes.indexOf(e[0])) {
var C;
(C = new o()).bindCell = p;
C.numIsStress = !1;
C.style = o.STYLE_RELATION;
C.notesStress = [ e[0] ];
this.relationCells.push(C);
}
}
} catch (e) {
i = {
error: e
};
} finally {
try {
y && !y.done && (a = f.return) && a.call(f);
} finally {
if (i) throw i.error;
}
}
};
l.prototype.getWrittenCells = function(e, t, l, r) {
var n, s, i, a;
void 0 === r && (r = "row");
var u = [], c = [];
if ("row" == r) {
u = this.sudoku.rowCells[t];
c = this.sudoku.palaceCells[l].filter(function(e) {
return e.rowIndex != t;
});
} else {
u = this.sudoku.columnCells[t];
c = this.sudoku.palaceCells[l].filter(function(e) {
return e.columnIndex != t;
});
}
try {
for (var h = __values(u), d = h.next(); !d.done; d = h.next()) if ((p = d.value).notes.length > 0 && -1 != p.notes.indexOf(e[0])) {
(C = new o()).bindCell = p;
C.numIsStress = !1;
C.style = o.STYLE_RELATION;
C.notesStress = [ e[0] ];
this.relationCells.push(C);
}
} catch (e) {
n = {
error: e
};
} finally {
try {
d && !d.done && (s = h.return) && s.call(h);
} finally {
if (n) throw n.error;
}
}
try {
for (var f = __values(c), y = f.next(); !y.done; y = f.next()) {
var p;
if ((p = y.value).notes.length > 0 && -1 != p.notes.indexOf(e[0])) {
var C;
(C = new o()).bindCell = p;
C.numIsStress = !1;
C.style = o.STYLE_AFFECTED;
C.notesRemove = [ e[0] ];
this.relationCells.push(C);
}
}
} catch (e) {
i = {
error: e
};
} finally {
try {
y && !y.done && (a = f.return) && a.call(f);
} finally {
if (i) throw i.error;
}
}
};
l.prototype.blockToRow = function(e) {
var t = this.sudoku.palaceCells[e], l = this.mergerUniqueArr(this.getCellNotes([ t[0], t[1], t[2] ])), o = this.mergerUniqueArr(this.getCellNotes([ t[3], t[4], t[5] ])), r = this.mergerUniqueArr(this.getCellNotes([ t[6], t[7], t[8] ])), n = l.concat(o).concat(r), s = this.checkOne(this.arrayCountValue(n)), i = 0;
if (s.length > 0) for (var a = function(l) {
var o, r;
try {
for (var n = (o = void 0, __values(t)), a = n.next(); !a.done; a = n.next()) {
var c = a.value;
if (-1 != c.notes.indexOf(s[l])) {
i = c.rowIndex;
break;
}
}
} catch (e) {
o = {
error: e
};
} finally {
try {
a && !a.done && (r = n.return) && r.call(n);
} finally {
if (o) throw o.error;
}
}
if (u.sudoku.rowCells[i].filter(function(t) {
return t.palaceIndex != e && 0 == t.questionOrAnswer && -1 != t.notes.indexOf(s[l]);
}).length > 0) return {
value: {
data: [ s[l] ],
row: i
}
};
}, u = this, c = 0; c < s.length; c++) {
var h = a(c);
if ("object" == typeof h) return h.value;
}
return {
data: [],
row: 0
};
};
l.prototype.blockToColumn = function(e) {
var t = this.sudoku.palaceCells[e], l = this.mergerUniqueArr(this.getCellNotes([ t[0], t[3], t[6] ])), o = this.mergerUniqueArr(this.getCellNotes([ t[1], t[4], t[7] ])), r = this.mergerUniqueArr(this.getCellNotes([ t[2], t[5], t[8] ])), n = l.concat(o).concat(r), s = this.checkOne(this.arrayCountValue(n));
if (s.length > 0) for (var i = function(l) {
var o, r, n = 0;
try {
for (var i = (o = void 0, __values(t)), u = i.next(); !u.done; u = i.next()) {
var c = u.value;
-1 != c.notes.indexOf(s[l]) && (n = c.columnIndex);
}
} catch (e) {
o = {
error: e
};
} finally {
try {
u && !u.done && (r = i.return) && r.call(i);
} finally {
if (o) throw o.error;
}
}
if (a.sudoku.columnCells[n].filter(function(t) {
return t.palaceIndex != e && 0 == t.questionOrAnswer && -1 != t.notes.indexOf(s[l]);
}).length > 0) return {
value: {
data: [ s[l] ],
column: n
}
};
}, a = this, u = 0; u < s.length; u++) {
var c = i(u);
if ("object" == typeof c) return c.value;
}
return {
data: [],
column: 0
};
};
l.prototype.getBlock = function(e, t) {
void 0 === t && (t = "row");
var l;
l = "row" == t ? this.sudoku.rowCells[e] : this.sudoku.columnCells[e];
var o = this.mergerUniqueArr(this.getCellNotes([ l[0], l[1], l[2] ])), r = this.mergerUniqueArr(this.getCellNotes([ l[3], l[4], l[5] ])), n = this.mergerUniqueArr(this.getCellNotes([ l[6], l[7], l[8] ])), s = o.concat(r).concat(n), i = this.checkOne(this.arrayCountValue(s));
if (i.length > 0) for (var a = function(o) {
var r, n, s = 0;
try {
for (var a = (r = void 0, __values(l)), c = a.next(); !c.done; c = a.next()) {
var h = c.value;
if (-1 != h.notes.indexOf(i[o])) {
s = h.palaceIndex;
break;
}
}
} catch (e) {
r = {
error: e
};
} finally {
try {
c && !c.done && (n = a.return) && n.call(a);
} finally {
if (r) throw r.error;
}
}
if (("row" == t ? u.sudoku.palaceCells[s].filter(function(t) {
return t.rowIndex != e && 0 == t.questionOrAnswer && -1 != t.notes.indexOf(i[o]);
}) : u.sudoku.palaceCells[s].filter(function(t) {
return 0 == t.questionOrAnswer && t.columnIndex != e && -1 != t.notes.indexOf(i[o]);
})).length > 0) return {
value: {
data: [ i[o] ],
palace: s
}
};
}, u = this, c = 0; c < i.length; c++) {
var h = a(c);
if ("object" == typeof h) return h.value;
}
return {
data: [],
palace: 0
};
};
l.prototype.checkOne = function(e) {
var t = [];
for (var l in e) 1 == e[l] && t.push(Number(l));
return t;
};
l.prototype.findColumnRowStep = function() {
var t, l, o = __read([ [], [], [], [], [] ], 5), i = o[0], a = o[1], u = o[2], c = o[3], h = o[4];
try {
for (var d = __values(this.relationCells), f = d.next(); !f.done; f = d.next()) {
var y = f.value;
if (y.style == e.AnalysisCell.STYLE_RELATION) {
i.push("<b><color=" + s.tipsCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
u.push(this.clone(y));
h = y.notesStress;
}
if (y.style == e.AnalysisCell.STYLE_AFFECTED) {
a.push("<b><color=" + s.AffectedCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
c.push(this.clone(y));
}
}
} catch (e) {
t = {
error: e
};
} finally {
try {
f && !f.done && (l = d.return) && l.call(d);
} finally {
if (t) throw t.error;
}
}
var p, C = "";
if (this.relationColumn.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b> 列";
p = {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b>"
};
} else if (this.relationRows.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b> 行";
p = {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b>"
};
} else if (this.relationPalace.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫";
p = {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
};
}
this.descKey = "qksjf0";
this.descData = [ [ p ], "<b><color=" + s.tipsNumStyle + ">" + h + "</color></b>", [ {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
} ], i.join("、"), a.join("、"), "<b><color=" + s.delNumStyle + ">" + h + "</color></b>" ];
var b = new r();
b.noFrameRows = this.relationRows;
b.noFrameColumn = this.relationColumn;
b.noFramePalace = this.relationPalace;
b.supplyIndex = this.supplyIndex;
b.supplyNotes = this.supplyNotes;
b.relationCells = this.clone(u);
b.relationCells.map(function(e) {
return e.notesStress = [];
});
var m = new n();
m.relationColumn = this.relationColumn;
m.relationRows = this.relationRows;
b.subStep.push(m);
var v = new n();
v.relationPalace = this.relationPalace;
b.subStep.push(v);
b.desc = "留意" + C + "和第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫，以及这些区域中出现的数字。";
b.descKey = "xxwyhxs1";
b.descData = [ [ p ] ];
var w = new r();
w.relationRows = this.relationRows;
w.relationColumn = this.relationColumn;
w.relationPalace = this.relationPalace;
w.supplyIndex = this.supplyIndex;
w.supplyNotes = this.supplyNotes;
w.relationCells = this.clone(u);
var x = new n();
x.relationCells = this.clone(u);
w.subStep.push(x);
w.desc = C + "数字 <b><color=" + s.tipsNumStyle + ">" + h + "</color></b> 只出现在 " + i.join("、") + " 中那么这两个单元格中有一个必然填 <b><color=" + s.tipsNumStyle + ">" + h + "</color></b> 。";
w.descKey = "qksjf1";
w.descData = [ [ p ], "<b><color=" + s.tipsNumStyle + ">" + h + "</color></b>", i.join("、") ];
var S = this.clone(w);
S.subStep = [];
S.relationCells = this.clone(u);
S.relationCells.map(function(e) {
return e.notesStress = [];
});
S.relationCells = S.relationCells.concat(c);
var g = new n();
g.relationCells = c;
S.subStep.push(g);
S.desc = "那么第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫的 " + a.join("、") + " 中的候选数 <b><color=" + s.delNumStyle + ">" + h + "</color></b> 就需要删除了。";
S.descKey = "qksjf2";
S.descData = [ [ {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
} ], a.join("、"), "<b><color=" + s.delNumStyle + ">" + h + "</color></b>" ];
this.step = [ b, w, S ];
};
l.prototype.findPalaceColumnRowStep = function() {
var t, l, o = __read([ [], [], [], [], [] ], 5), i = o[0], a = o[1], u = o[2], c = o[3], h = o[4];
try {
for (var d = __values(this.relationCells), f = d.next(); !f.done; f = d.next()) {
var y = f.value;
if (y.style == e.AnalysisCell.STYLE_RELATION) {
i.push("<b><color=" + s.tipsCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
u.push(this.clone(y));
h = y.notesStress;
}
if (y.style == e.AnalysisCell.STYLE_AFFECTED) {
a.push("<b><color=" + s.AffectedCellStyle + ">" + y.bindCell.coordinate + "</color></b>");
c.push(this.clone(y));
}
}
} catch (e) {
t = {
error: e
};
} finally {
try {
f && !f.done && (l = d.return) && l.call(d);
} finally {
if (t) throw t.error;
}
}
var p, C = "";
if (this.relationColumn.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b> 列";
p = {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationColumn[0] + 1) + "</color></b>"
};
} else if (this.relationRows.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b> 行";
p = {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(this.relationRows[0]) + "</color></b>"
};
} else if (this.relationPalace.length > 0) {
C = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫";
p = {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
};
}
this.descKey = "qksjf0";
this.descData = [ [ {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
} ], "<b><color=" + s.tipsNumStyle + ">" + h + "</color></b>", [ p ], i.join("、"), a.join("、"), "<b><color=" + s.delNumStyle + ">" + h + "</color></b>" ];
var b = new r();
b.noFrameRows = this.relationRows;
b.noFrameColumn = this.relationColumn;
b.noFramePalace = this.relationPalace;
b.supplyIndex = this.supplyIndex;
b.supplyNotes = this.supplyNotes;
b.relationCells = this.clone(u);
b.relationCells.map(function(e) {
return e.notesStress = [];
});
var m = new n();
m.relationPalace = this.relationPalace;
b.subStep.push(m);
var v = new n();
v.relationColumn = this.relationColumn;
v.relationRows = this.relationRows;
b.subStep.push(v);
b.desc = "留意第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫和" + C + "，以及这些区域中出现的数字。";
b.descKey = "xxwyhxs1";
b.descData = [ [ {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
} ] ];
var w = new r();
w.relationRows = this.relationRows;
w.relationColumn = this.relationColumn;
w.relationPalace = this.relationPalace;
w.supplyIndex = this.supplyIndex;
w.supplyNotes = this.supplyNotes;
w.relationCells = this.clone(u);
var x = new n();
x.relationCells = this.clone(u);
w.subStep.push(x);
w.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b> 宫数字 <b><color=" + s.tipsNumStyle + ">" + h + "</color></b> 只出现在 " + i.join("、") + " 中那么这两个单元格中有一个必然填 <b><color=" + s.tipsNumStyle + ">" + h + "</color></b> 。";
w.descKey = "qksjf1";
w.descData = [ [ {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (this.relationPalace[0] + 1) + "</color></b>"
} ], "<b><color=" + s.tipsNumStyle + ">" + h + "</color></b>", i.join("、") ];
var S = this.clone(w);
S.subStep = [];
S.relationCells = this.clone(u);
S.relationCells.map(function(e) {
return e.notesStress = [];
});
S.relationCells = S.relationCells.concat(c);
var g = new n();
g.relationCells = c;
S.subStep.push(g);
S.desc = "那么" + C + "的 " + a.join("、") + " 中的候选数 <b><color=" + s.delNumStyle + ">" + h + "</color></b> 就需要删除了。";
S.descKey = "qksjf2";
S.descData = [ [ p ], a.join("、"), "<b><color=" + s.delNumStyle + ">" + h + "</color></b>" ];
this.step = [ b, w, S ];
};
return l;
}(s);
e.DlockDeletion = f;
var y = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.name = "存在多个错误";
t.desc = "以上高亮单元格存在错误，需要先进行修复。";
return t;
}
t.prototype.findSukudu = function(e, t) {
for (var l = this, r = __read([ 0, 0, 0 ], 3), n = r[0], s = r[1], i = r[2], a = 0; a < 81; a++) if (0 != e[a] && e[a] != this.sudoku.cells[a].right) {
var u = new o();
u.bindCell = this.sudoku.cells[a];
u.style = o.STYLE_ERROR;
u.numIsStress = !0;
this.relationCells.push(u);
this.sudoku.cells[a].answer = 0;
n = 1;
} else this.sudoku.cells[a].answer = e[a];
this.sudoku.fillAllNote();
var c = function(e) {
if (t[e].length > 0) {
h.sudoku.cells[e].notes = t[e];
h.sudoku.cells[e].userNotes = t[e];
if (1 == t[e].length && t[e][0] == h.sudoku.cells[e].right) return "continue";
var r = t[e].filter(function(t) {
return -1 == l.sudoku.cells[e].systemNotes.indexOf(t);
}), n = new o();
n.bindCell = h.sudoku.cells[e];
if (-1 == t[e].indexOf(h.sudoku.cells[e].right)) {
n.notesAdd = h.sudoku.cells[e].systemNotes.filter(function(l) {
return -1 == t[e].indexOf(l);
});
s = 1;
}
if (r.length > 0) {
n.notesRemove = r;
i = 1 == i ? 1 : 1 == s ? 0 : 1;
}
(r.length > 0 || -1 == t[e].indexOf(h.sudoku.cells[e].right)) && h.relationCells.push(n);
} else h.sudoku.cells[e].notes = h.sudoku.cells[e].systemNotes;
}, h = this;
for (a = 0; a < 81; a++) c(a);
if (this.relationCells.length > 0) {
if (1 == n) {
this.name = "存在错误的答案";
this.desc = "以上单元格存在错误的答案，需要先进行清理。";
this.descKey = "xfbj1";
}
if (1 == s) {
this.name = "存在错误的笔记";
this.desc = "以上单元格存在错误的笔记，需要先进行修复。";
this.descKey = "xfbj2";
}
if (1 == i) {
this.name = "存在多余的笔记";
this.desc = "以上单元格存在多余的笔记，需要先进行清理。";
this.descKey = "xfbj3";
}
if (n + s + i > 1) {
this.name = "存在多个错误";
this.desc = "以上高亮单元格存在错误，需要先进行修复。";
this.descKey = "xfbj4";
}
return this;
}
return null;
};
return t;
}(s);
e.CheckUserSukudu = y;
var p = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.name = "显性唯一候选数";
return t;
}
t.prototype.find = function() {
return this.checkRow() ? this : this.checkColumn() ? this : this.checkPalace() ? this : null;
};
t.prototype.checkRow = function() {
for (var e = 0; e < 9; e++) if (!(this.sudoku.rowCells[e].filter(function(e) {
return 0 == e.questionOrAnswer && 0 == e.userNotes.length;
}).length > 0)) {
if (1 == this.sudoku.rowCells[e].filter(function(e) {
return 0 == e.questionOrAnswer;
}).length) return !1;
var t = this.sudoku.rowCells[e].filter(function(e) {
return 0 == e.questionOrAnswer && 1 == e.userNotes.length;
});
if (t.length > 0) {
var l = new o();
l.bindCell = t[0];
l.notesUnique = t[0].userNotes[0];
l.style = o.STYLE_AFFECTED;
this.relationCells.push(l);
this.relationRows = [ e ];
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(e) + "</color></b> 行中，<b><color=" + s.AffectedCellStyle + ">" + t[0].coordinate + "</color></b> 仅剩余候选数 <b><color=" + s.tipsNumStyle + ">" + t[0].userNotes[0] + "</color></b>，那么该候选数即为答案。";
this.descKey = "xxwyhxs4";
this.descData = [ [ {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(e) + "</color></b>"
} ], "<b><color=" + s.AffectedCellStyle + ">" + t[0].coordinate + "</color></b>", "<b><color=" + s.tipsNumStyle + ">" + t[0].userNotes[0] + "</color></b>" ];
return !0;
}
}
return !1;
};
t.prototype.checkColumn = function() {
for (var e = 0; e < 9; e++) if (!(this.sudoku.columnCells[e].filter(function(e) {
return 0 == e.questionOrAnswer && 0 == e.userNotes.length;
}).length > 0)) {
if (1 == this.sudoku.columnCells[e].filter(function(e) {
return 0 == e.questionOrAnswer;
}).length) return !1;
var t = this.sudoku.columnCells[e].filter(function(e) {
return 0 == e.questionOrAnswer && 1 == e.userNotes.length;
});
if (t.length > 0) {
var l = new o();
l.bindCell = t[0];
l.notesUnique = t[0].userNotes[0];
l.style = o.STYLE_AFFECTED;
this.relationCells.push(l);
this.relationColumn = [ e ];
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e + 1) + "</color></b> 列中，<b><color=" + s.AffectedCellStyle + ">" + t[0].coordinate + "</color></b> 仅剩余候选数 <b><color=" + s.tipsNumStyle + ">" + t[0].userNotes[0] + "</color></b>，那么该候选数即为答案。";
this.descKey = "xxwyhxs4";
this.descData = [ [ {
type: "c",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e + 1) + "</color></b>"
} ], "<b><color=" + s.AffectedCellStyle + ">" + t[0].coordinate + "</color></b>", "<b><color=" + s.tipsNumStyle + ">" + t[0].userNotes[0] + "</color></b>" ];
return !0;
}
}
return !1;
};
t.prototype.checkPalace = function() {
for (var e = 0; e < 9; e++) if (!(this.sudoku.palaceCells[e].filter(function(e) {
return 0 == e.questionOrAnswer && 0 == e.userNotes.length;
}).length > 0)) {
if (1 == this.sudoku.palaceCells[e].filter(function(e) {
return 0 == e.questionOrAnswer;
}).length) return !1;
var t = this.sudoku.palaceCells[e].filter(function(e) {
return 0 == e.questionOrAnswer && 1 == e.userNotes.length;
});
if (t.length > 0) {
var l = new o();
l.bindCell = t[0];
l.notesUnique = t[0].userNotes[0];
l.style = o.STYLE_AFFECTED;
this.relationCells.push(l);
this.relationPalace = [ e ];
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e + 1) + "</color></b> 宫中，<b><color=" + s.AffectedCellStyle + ">" + t[0].coordinate + "</color></b> 仅剩余候选数 <b><color=" + s.tipsNumStyle + ">" + t[0].userNotes[0] + "</color></b>，那么该候选数即为答案。";
this.descKey = "xxwyhxs4";
this.descData = [ [ {
type: "b",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + (e + 1) + "</color></b>"
} ], "<b><color=" + s.AffectedCellStyle + ">" + t[0].coordinate + "</color></b>", "<b><color=" + s.tipsNumStyle + ">" + t[0].userNotes[0] + "</color></b>" ];
return !0;
}
}
return !1;
};
return t;
}(s);
e.CheckUserNoteShowOne = p;
var C = function(e) {
__extends(t, e);
function t() {
var t = null !== e && e.apply(this, arguments) || this;
t.name = "隐性唯一候选数法";
return t;
}
t.prototype.find = function() {
return this.checkRow() ? this : this.checkColumn() ? this : this.checkPalace() ? this : null;
};
t.prototype.checkRow = function() {
for (var e, t, l, r, n = 0; n < 9; n++) if (!(this.sudoku.rowCells[n].filter(function(e) {
return 0 == e.questionOrAnswer && 0 == e.userNotes.length;
}).length > 0)) {
if (1 == this.sudoku.rowCells[n].filter(function(e) {
return 0 == e.questionOrAnswer;
}).length) return !1;
var i = [];
try {
for (var a = (e = void 0, __values(this.sudoku.rowCells[n])), u = a.next(); !u.done; u = a.next()) (f = u.value).userNotes.length > 0 && i.push(f.userNotes);
} catch (t) {
e = {
error: t
};
} finally {
try {
u && !u.done && (t = a.return) && t.call(a);
} finally {
if (e) throw e.error;
}
}
var c = this.hideCombination(i, 1);
if (c.length > 0) try {
for (var h = (l = void 0, __values(this.sudoku.rowCells[n])), d = h.next(); !d.done; d = h.next()) {
var f;
if ((f = d.value).userNotes.length > 1 && -1 != f.userNotes.indexOf(c[0]) && c[0] == f.right) {
var y = new o();
y.bindCell = f;
y.notesStress = [ c[0] ];
y.style = o.STYLE_AFFECTED;
y.numWrite = c[0];
this.relationCells.push(y);
this.relationRows = [ n ];
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(n) + "</color></b> 行中，候选数 <b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b> 仅出现在 <b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b> 中，那么 <b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b> 答案应当填 <b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b> 。";
this.descKey = "yxwyhxs4";
this.descData = [ {
type: "r",
value: "<b><color=" + s.tipsRowColumnPalaceStyle + ">" + this.rowNumberToLetter(n) + "</color></b>"
}, "<b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b>", "<b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b>" ];
this.getStep();
return !0;
}
}
} catch (e) {
l = {
error: e
};
} finally {
try {
d && !d.done && (r = h.return) && r.call(h);
} finally {
if (l) throw l.error;
}
}
}
return !1;
};
t.prototype.checkColumn = function() {
for (var e, t, l, r, n = 0; n < 9; n++) if (!(this.sudoku.columnCells[n].filter(function(e) {
return 0 == e.questionOrAnswer && 0 == e.userNotes.length;
}).length > 0)) {
if (1 == this.sudoku.columnCells[n].filter(function(e) {
return 0 == e.questionOrAnswer;
}).length) return !1;
var i = [];
try {
for (var a = (e = void 0, __values(this.sudoku.columnCells[n])), u = a.next(); !u.done; u = a.next()) (f = u.value).userNotes.length > 0 && i.push(f.userNotes);
} catch (t) {
e = {
error: t
};
} finally {
try {
u && !u.done && (t = a.return) && t.call(a);
} finally {
if (e) throw e.error;
}
}
var c = this.hideCombination(i, 1);
if (c.length > 0) try {
for (var h = (l = void 0, __values(this.sudoku.columnCells[n])), d = h.next(); !d.done; d = h.next()) {
var f;
if ((f = d.value).userNotes.length > 1 && -1 != f.userNotes.indexOf(c[0]) && c[0] == f.right) {
var y = new o();
y.bindCell = f;
y.notesStress = [ c[0] ];
y.style = o.STYLE_AFFECTED;
y.numWrite = c[0];
this.relationCells.push(y);
this.relationColumn = [ n ];
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (n + 1) + "</color></b> 列中，候选数 <b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b> 仅出现在 <b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b> 中，那么 <b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b> 答案应当填 <b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b> 。";
this.getStep();
return !0;
}
}
} catch (e) {
l = {
error: e
};
} finally {
try {
d && !d.done && (r = h.return) && r.call(h);
} finally {
if (l) throw l.error;
}
}
}
return !1;
};
t.prototype.checkPalace = function() {
for (var e, t, l, r, n = 0; n < 9; n++) if (!(this.sudoku.palaceCells[n].filter(function(e) {
return 0 == e.questionOrAnswer && 0 == e.userNotes.length;
}).length > 0)) {
if (1 == this.sudoku.palaceCells[n].filter(function(e) {
return 0 == e.questionOrAnswer;
}).length) return !1;
var i = [];
try {
for (var a = (e = void 0, __values(this.sudoku.palaceCells[n])), u = a.next(); !u.done; u = a.next()) (f = u.value).userNotes.length > 0 && i.push(f.userNotes);
} catch (t) {
e = {
error: t
};
} finally {
try {
u && !u.done && (t = a.return) && t.call(a);
} finally {
if (e) throw e.error;
}
}
var c = this.hideCombination(i, 1);
if (c.length > 0) try {
for (var h = (l = void 0, __values(this.sudoku.palaceCells[n])), d = h.next(); !d.done; d = h.next()) {
var f;
if ((f = d.value).userNotes.length > 1 && -1 != f.userNotes.indexOf(c[0]) && c[0] == f.right) {
var y = new o();
y.bindCell = f;
y.notesStress = [ c[0] ];
y.style = o.STYLE_AFFECTED;
y.numWrite = c[0];
this.relationCells.push(y);
this.relationPalace = [ n ];
this.desc = "第 <b><color=" + s.tipsRowColumnPalaceStyle + ">" + (n + 1) + "</color></b> 宫中，候选数 <b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b> 仅出现在 <b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b> 中，那么 <b><color=" + s.AffectedCellStyle + ">" + f.coordinate + "</color></b> 答案应当填 <b><color=" + s.tipsNumStyle + ">" + c[0] + "</color></b> 。";
this.getStep();
return !0;
}
}
} catch (e) {
l = {
error: e
};
} finally {
try {
d && !d.done && (r = h.return) && r.call(h);
} finally {
if (l) throw l.error;
}
}
}
return !1;
};
return t;
}(s);
e.CheckUserNoteHideOne = C;
})(window.sudoku9solution || (window.sudoku9solution = {}));