var game, __read = this && this.__read || function(t, e) {
var r = "function" == typeof Symbol && t[Symbol.iterator];
if (!r) return t;
var i, n, o = r.call(t), s = [];
try {
for (;(void 0 === e || e-- > 0) && !(i = o.next()).done; ) s.push(i.value);
} catch (t) {
n = {
error: t
};
} finally {
try {
i && !i.done && (r = o.return) && r.call(o);
} finally {
if (n) throw n.error;
}
}
return s;
}, __spreadArray = this && this.__spreadArray || function(t, e, r) {
if (r || 2 === arguments.length) for (var i, n = 0, o = e.length; n < o; n++) if (i || !(n in e)) {
i || (i = Array.prototype.slice.call(e, 0, n));
i[n] = e[n];
}
return t.concat(i || Array.prototype.slice.call(e));
};

(function(t) {
var e = function() {
function e() {
this.taskId = 10;
this.type = 9;
this.gameScene = t.SudokuQuestion.GAMESCENE_DAILY;
this.difficulty = t.SudokuQuestion.DIFFICULTY_EXPERT;
this.beginTime = 0;
this.longTime = 0;
this.lastOpenTime = 0;
this.question = [];
this.answer = [];
this.notes = [];
this.right = [];
this.level = 0;
this.fluctuateLevel = 0;
this.date = 0;
this.lockNum = 0;
this.isNote = !1;
this.selectCellIndex = -1;
this.errorCount = 0;
this.allErrorCount = 0;
this.cellIndexLastWrite = -1;
this.freeTips = 0;
this.adTips = 0;
this.maxFreeTips = 5;
this.useTipsCount = 0;
this.isGuideLevel = !1;
this.curQI = 0;
this.topScore = 0;
this.curScore = 0;
this.clearScore = 0;
this.evaluationIdx = 1;
this.longPressLockNumCount = 0;
this.longPressUnLockNumCount = 0;
this.clickDoubleAnswer = 0;
this.clickDoubleNote = 0;
this.clickDoubleErase = 0;
this.beginSource = "默认";
this.isSendBiginGame = !1;
this._writeTrans = [];
this.activityLevel = 0;
this.activityName = "";
this.activityReward = 0;
this.resurgenceCount = 0;
}
Object.defineProperty(e.prototype, "progress", {
get: function() {
var t = 2 * this.question.filter(function(t) {
return 0 === t;
}).length, e = 2 * this.answer.filter(function(t) {
return t > 0;
}).length + this.notes.filter(function(t) {
return t.length > 0;
}).length;
return Math.floor(e / t * 100) / 100;
},
enumerable: !1,
configurable: !0
});
e.prototype.isSucceed = function() {
var t = this;
return 0 > this.right.findIndex(function(e, r) {
return 0 === t.question[r] && e !== t.answer[r];
});
};
e.prototype.isFail = function() {
return !this.isGuideLevel && 3 <= this.errorCount;
};
e.prototype.reset = function() {
this.notes = new Array(this.notes.length).fill([]);
this.answer = new Array(this.answer.length).fill(0);
this.longTime = 0;
this.errorCount = 0;
};
e.generator = function(t) {
var r = new e();
r.question = __spreadArray([], __read(t.question), !1);
r.right = __spreadArray([], __read(t.right), !1);
for (var i = 0, n = r.question.length; i < n; i++) {
r.notes.push([]);
r.answer.push(0);
}
r.type = t.type;
r.gameScene = t.gameScene;
r.level = t.level;
r.date = t.date;
r.difficulty = t.difficulty;
r.selectCellIndex = r.getFirstNoEmptyCell();
return r;
};
e.test = function(t) {
var r = new e();
r.question = __spreadArray([], __read(t.question), !1);
r.right = __spreadArray([], __read(t.right), !1);
for (var i = 0, n = r.question.length; i < n; i++) {
r.notes.push([]);
r.answer.push(0);
}
r.type = t.type;
r.gameScene = t.gameScene;
r.level = t.level;
r.date = t.date;
r.difficulty = t.difficulty;
r.selectCellIndex = r.getFirstNoEmptyCell();
return r;
};
e.prototype.actionPush = function(t) {
this._writeTrans.push(t);
};
e.prototype.actionPop = function() {
return 0 < this._writeTrans.length ? this._writeTrans.pop() : null;
};
e.prototype.actionSize = function() {
return this._writeTrans.length;
};
e.prototype.actionClear = function() {
this._writeTrans = [];
};
e.prototype.getLongTimeString = function() {
var t = Math.floor(this.longTime), e = ("0" + Math.floor(t / 3600).toString()).substr(-2), r = ("0" + Math.floor(t % 3600 / 60).toString()).substr(-2), i = ("0" + (t % 60).toString()).substr(-2);
return (0 < Math.floor(t / 3600) ? e + ":" : "") + r + ":" + i;
};
e.prototype.getDateStr = function() {
var t = new Date();
return t.getFullYear() + "." + (t.getMonth() + 1) + "." + t.getDate();
};
e.prototype.saveTaskLocal = function(t) {
storagecache.LocalStorage.setItem(t, this);
};
e.loadTaskLocal = function(t) {
var r = storagecache.LocalStorage.getItem(t);
if (r) {
var i = new e();
Object.assign(i, r);
return i;
}
return null;
};
e.prototype.getFirstNoEmptyCell = function() {
switch (this.type) {
case t.SudokuQuestion.TYPE_9:
for (var e = 0; e < 9; e++) for (var r = 0; r < 9; r++) {
var i = 9 * (3 * Math.floor(e / 3) + Math.floor(r / 3)) + e % 3 * 3 + r % 3;
if (0 === this.question[i] && 0 === this.answer[i]) return i;
}
}
return 0;
};
e.prototype.addScore = function(t) {
this.curScore += t;
this.curScore > this.topScore && (this.topScore = this.curScore);
};
e.currentTask = null;
return e;
}();
t.SudokuTask = e;
})(window.game || (window.game = {}));